    
    // funcao para criar mosaico by matheus   
    function dynamicSort(property) {
        var sortOrder = 1;
        if(property[0] === "-") {
            sortOrder = -1;
            property = property.substr(1);
        }
        return function (a,b) {
            var result = (a[property] < b[property]) ? -1 : (a[property] > b[property]) ? 1 : 0;
            return result * sortOrder;
        }
    }    
    
    //function alert, setei aqui pra usar no app inteiro
    function showMessage(message, title, buttonName){
        document.addEventListener("deviceready", onDeviceReady, true);
                function onDeviceReady() {
                    if (window.cordova.platformId == "browser")
                        console.log('xablau');
                    else
                        navigator.notification.alert(message, function(){}, title, buttonName);
                } 
    }

    function preLoadType(type,title,message) {
        document.addEventListener("deviceready", function() {
            if(type == 'insert')
                window.plugins.spinnerDialog.show(title,message,localStorage.getItem('status'));
            else 
                window.plugins.spinnerDialog.hide();

        }, false);
    }

    function handleOpenURL(url) {
        // This function is triggered by the LaunchMyApp Plugin
        preLoadType('insert');        
        var resurl = url.replace("primepassapp://","/");
        localStorage.setItem('urlDeepLink',resurl);
    }

    document.addEventListener("deviceready", function(status) {
           // alert(JSON.stringify(status));

    }, false);
    
    // Main controller
    myApp.controller('mainController', ['$scope', '$interval', '$location', '$rootScope','$timeout','user', 'app','$window','$base64','contato','snapRemote','$mdDialog','$mdToast', '$mdSidenav', 'cinemas', function($scope, $interval, $location, $rootScope,$timeout,user,$app,$window,$base64,$contato,snapRemote, $mdDialog, $mdToast, $mdSidenav, cinemas){
        // facebookConnectPlugin.browserInit('266893383664619','v2.4'); // inicia o app facebook only browser needs it

        function onDeviceReady() {

            $timeout(function(){
                navigator.splashscreen.hide();
            },1000);

            // alert('estou aqui por segundo ou primeiro');

            document.addEventListener("online", onOnline, false);

            function onOnline() {
                window.location.reload(true);
            }
            
            function checkConnection() {
                                               
                var networkState = navigator.connection.type;

                if(networkState == Connection.NONE) {
                    $mdToast.show(
                        $mdToast.simple({
                            textContent :   'Detectamos problemas com sua conexão.',
                            hideDelay   :   60000,
                            position    :   'top left',
                            action      :   'x',
                            templateUrl :   'views/modal/message-connection.tmpl.html'
                    }));
                    $rootScope.initiated = 1;
                } else {                    
                    $rootScope.initiated = 0;
                }
            }

            checkConnection();            
                    
            window.plugins.uniqueDeviceID.get(success, error);

            function success(uuid) {
                // alert(uuid);
                localStorage.setItem("deviceInfo",JSON.stringify({device_uuid:uuid, platform:device.platform, model: device.model}));
            }

            function error(message) {
                console.log(message);
            }    
            
            //enable urban notifications
            // $rootScope.urban.enablePush();

            //set device to ready
            $rootScope.deviceReady = true;
                    
            //remove status bar(iphone/android)
            StatusBar.overlaysWebView(true);
            StatusBar.hide();

            //show iphone keyboard accessory
            cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);

            //looping 10s para verificar status internet/gps
            $interval(function(){                
                Components.init();
            }, 10000);

            //verificar ultima versao do aplicativo
            if(!localStorage.getItem("deviceInfo")) {
                console.log('faz nada aqui');
            } else {
                var infos = JSON.parse(localStorage.getItem('deviceInfo'));
                console.log(infos.platform);
                $scope.checkAppVersion(infos.platform);
            }

            //show or not leave option on menu
            if(device.platform == 'iOS')
                $scope.showLeave = 'false';
            else
                $scope.showLeave = 'true';

            /* 
            * lista de cinemas com geolocalizacao
            * sim, vou carregar isso quando abre o app, porque tem que ser assim
            */
            cinemas.getPosition(function (pos) {
                cinemas.getList(pos.coords.latitude, pos.coords.longitude).then(function(response){
                    $rootScope.cinemas = response.data;
                    $rootScope.statusCinema = response.status;
                });
            });
        }
        

        $scope.toggleLeft = buildDelayedToggler('left');
        $scope.toggleRight = buildToggler('right');
        $scope.isOpenRight = function(){
          return $mdSidenav('right').isOpen();
        };

        /**
         * Supplies a function that will continue to operate until the
         * time is up.
         */
        function debounce(func, wait, context) {
          var timer;

          return function debounced() {
            var context = $scope,
                args = Array.prototype.slice.call(arguments);
            $timeout.cancel(timer);
            timer = $timeout(function() {
              timer = undefined;
              func.apply(context, args);
            }, wait || 10);
          };
        }

        /**
         * Build handler to open/close a SideNav; when animation finishes
         * report completion in console
         */
        function buildDelayedToggler(navID) {
          return debounce(function() {
            // Component lookup should always be available since we are not using `ng-if`
            $mdSidenav(navID)
              .toggle()
              .then(function () {
                $log.debug("toggle " + navID + " is done");
              });
          }, 200);
        }

        function buildToggler(navID) {
          return function() {            
            $mdSidenav(navID)
              .toggle();
          }
        }

        // keyboard hide
        function keyboardHideHandler(e) {            
            var device = JSON.parse(localStorage.getItem('deviceInfo'));            
            // se for iphone, faz nada
            if(device.platform != 'iOS') {                
                jQuery('.nav').css('transform','translateY(0)');            
                jQuery('.nav').css('transition','.5s');
            }       
        }

        // //keyboard show
        function keyboardShowHandler(e){            
            var device = JSON.parse(localStorage.getItem('deviceInfo'));            
            //se for iphone nem faz nada
            if(device.platform != 'iOS'){
                if($location.url() == '/register'){
                    jQuery('.nav').css('transform','translateY(-130px)');
                    jQuery('.nav').css('transition','.5s');
                } else {
                    jQuery('.nav').css('transform','translateY(-160px)');            
                    jQuery('.nav').css('transition','.5s');
                }             
                // new version unlock
            }       
        }

        // events fires que me ajuda muito se funcionar
        // agora estou querendo suicidar-me, pq phonegap eh treta
        document.addEventListener('deviceready',onDeviceReady,false);
        window.addEventListener('native.keyboardshow', keyboardShowHandler);
        window.addEventListener('native.keyboardhide', keyboardHideHandler);
        
        //verifica se tem tutorial
        if(!localStorage.getItem("has_tutorial"))
            $location.path('/tutorial');

        if(!localStorage.getItem("newLogin")) {
            localStorage.removeItem("userPrime");
            localStorage.setItem("newLogin",true);
            $rootScope.is_log    = "false";
            $rootScope.imageUser = 'img/undefined.jpg';
            $rootScope.name__user    = 'Login';
        } else {
            // check if user is logged, to hide or show items on menu
            if(localStorage.getItem("userPrime")) {

                var userInfo = JSON.parse(localStorage.getItem("userPrime"));                        

                //login ativo
                $rootScope.is_log = "true";                                

                user.dataUser(userInfo.id)
                .then(function(response){

                    localStorage.setItem("userPrime",JSON.stringify(response.data));                                                
                    //foto user
                    $rootScope.imageUser = response.data.picture;
                    //nome + sobrenome
                    $rootScope.name__user    = response.data.name+' '+response.data.middlename;

                    $rootScope.cardact   = response.data.card_prime_ID;

                    localStorage.setItem("newLogin",true);
                });
            }else{

                $rootScope.is_log    = "false";
                $rootScope.imageUser = 'img/undefined.jpg';
                $rootScope.name__user    = 'Login';

            }
        }        

        //zera informacoes de outras sessoes sobre filme
        sessionStorage.setItem("sessionInformation",null);

        // Menu
        var history = [];
        $scope.showMenu = false;
        $scope.state = ""; 

        //modal-card
        $scope.modal = "";
        $scope.modalTicket = "";

        $scope.$watch(function () { return localStorage.getItem('urlDeepLink') },function(newVal,oldVal){            
            if(newVal != oldVal && newVal != null) {
                preLoadType('remove');
                $location.path(newVal);
                localStorage.removeItem('urlDeepLink');                
            }            
        });        

        // $scope.$watch(function () { $rootScope.deviceReady },function(newVal, oldVal) {
        //     if(newVal) {
        //         if(localStorage.getItem("userPrime")) {
            
        //             var user = JSON.parse(localStorage.getItem("userPrime"));                        

        //             $rootScope.urban.setName(response.data.name+' '+response.data.middlename,'insert');

        //             if(user.plan == 'empty') 
        //                 $rootScope.urban.setTag("User_Primepass");
        //             else
        //                 $rootScope.urban.setTag("Assinante_Primepass");
        //         }
        //     }
        // });        
    
        /**
        * evento que dispara toda vez antes de uma route ser totalmente carregada
        * legal para trabalhar eventos antes do carregamento
        **/

        $rootScope.$on("$routeChangeStart", function (event, next, current) {
            var _futureRoute = next.$$route.templateUrl;
            var _futureController = next.$$route.controller;

            if(_futureRoute == 'views/login.html' || _futureRoute == 'views/register.html') {
                if(localStorage.getItem("userPrime")) {
                    $location.path('/')
                }
            }

            if(_futureController == 'leaveController' && current.$$route.templateUrl == 'views/login.html') {
                $location.path('/');
            }

            if(_futureRoute == 'views/profile.html' && sessionStorage.getItem("movieID")) {
                $location.path(sessionStorage.getItem("movieID"));
            }
        });

        /**
        * evento que dispara toda vez que uma route é totalmente carregada
        **/

        $rootScope.$on("$routeChangeSuccess", function (event, currentRoute, previousRoute) {            
            
            /** Adiciona pages no history**/
            history.push($location.$$path);

            //zera os settings avulsos
            $rootScope.snavbar       = '';
            $rootScope.logo__icon    = '';
            $rootScope.burger__icon  = '';

            //fecha dialog quando troca pra outra pagina
            if(currentRoute.loadedTemplateUrl == 'views/moviesCinema.html' && $rootScope.activeMapView)
                $mdDialog.cancel();

            //fecha dialog quando troca pra outra pagina
            if(currentRoute.loadedTemplateUrl == 'views/login.html' && $rootScope.modalMovieCinema)
                $mdDialog.cancel();

            /** aplica fixed em todos paginas que nao precisam de scroll **/
            if(currentRoute.loadedTemplateUrl == 'views/register.html' || currentRoute.loadedTemplateUrl == 'views/login.html' || currentRoute.loadedTemplateUrl == 'views/moviesCinema.html' || currentRoute.loadedTemplateUrl == 'views/profile.html' || currentRoute.loadedTemplateUrl == 'views/card-success.html') {                
                $rootScope.sscrollbar = 'noscroll';
            } else {
                $rootScope.sscrollbar = '';
            }
            /** retira alguns efeitos de um plugin para funcionar perfeitamente em modais **/
            if(currentRoute.loadedTemplateUrl != 'views/plans.tmpl.html' || currentRoute.loadedTemplateUrl == 'views/tela-inicial.tmpl.html'){
                $rootScope.top = 'false';
            } else {
                $rootScope.top = 'true';
            }            
            
            /** Seta pages no GA**/                    
            $window.ga('send', 'screenview', {
                screenName : $location.url(),
                appName    : 'Primepass Mobile'
            });                    

            // retira barra de selecione sua sessao dos filmes em breve
            // ja que nao ha sessoes
            if(previousRoute) {

                if(previousRoute.loadedTemplateUrl == 'views/movielist-soon.html'){
                    $rootScope.hideTopBar = 'inactive';
                }else{
                    $rootScope.hideTopBar = '';
                }

                // zera informacoes sobre filme caso ele saia dos detalhes para escolher outro filme
                if(previousRoute.loadedTemplateUrl == 'views/movie-detail.html' && currentRoute.loadedTemplateUrl == 'views/home.html'){
                    sessionStorage.setItem("sessionInformation",null);
                }
            }

            /*
            * set menu to visible if the current page is login
            * or not if it is any another pageows
            */
            var param = currentRoute.loadedTemplateUrl;

            if(param == 'views/profile.html') {
                $scope.screenR = 'true';
            } else {
                $scope.screenR = 'false';
            }            
            
            // set icon back of navbar to hide
            // if page is home or card-success
            if(param == 'views/card-success.html' || param == 'views/home.html') {
                $rootScope.iconBack = 'inactive';
                $rootScope.logo__icon = 'home';
            }else{
                $rootScope.iconBack = '';
            }

            if(param == 'views/login.html') {
            
                $rootScope.snavbar = 'up';
                $rootScope.logo__icon    = 'inactive';
                $rootScope.burger__icon = 'inactive';

            } else {            
                $rootScope.snavbar = '';
            }
        });


        /**
        * Mostra ou não modal de ativar cartão
        */
        $rootScope.setModalState = function(){
            $scope.modal  = !$scope.modal ? 'active':'';            
            $scope.showMenu = false;
            $scope.state = '';
        }

        // modal de ticket do usuario
        $rootScope.setModaTicketlState = function(){
            $scope.modalTicket  = !$scope.modalTicket ? 'active':'';
            $scope.showMenu = false;
            $scope.state = '';
        }


        $rootScope.back = function () {
            var prevUrl = history.length > 1 ? history.splice(-2)[0] : "/";
            $location.path(prevUrl);
        };

        /*
         * Troca o estado do menu
         */
         $scope.setMenuState = function(){
            $scope.showMenu = !$scope.showMenu ? true:false;
            //lembrar de fazer
            $scope.state    = $scope.showMenu ? 'active':'';
         }
         
        $scope.reloadApp = function() {            
            $scope.setMenuState();
            window.location.reload(true);            
        }

        /**
         * Isso aqui vai checar a versão do aplicativo
         */
        $scope.checkAppVersion = function(platform) {
            $app.getVersion(platform).then(function(response) {
                var AppVersion  = app_version.split('.').join('');
                var LastVersion = response.version.split('.').join('');
                if(AppVersion < LastVersion) {                    
                    $scope.showAlertUpdateApp = true;
                }
            });
        }

        $scope.sendWhatsApp = function() {
            $contato.openWhatSapp();
        }

        $rootScope.setTutorialState = function() {
            localStorage.setItem("has_tutorial",true);
            console.log('aqui');
            $location.path('/');
        }

        $rootScope.leaveApp = function() {
             navigator.app.exitApp();
        }

        /**
         * Abre o aplicativo PrimePass na loja
         */
        $scope.openStore = function() {      
            var device = JSON.parse(localStorage.getItem('deviceInfo'));            
            if(device.platform == 'iOS')
                cordova.plugins.market.open("id932251566");
            else
                cordova.plugins.market.open(app_store_name);
        }

        /**
        * funcao para abrir termos e politicas no site
        * o certo eh consumir direto do wpp
        **/
        $rootScope.openTerms = function () {
            var url = "https://primepass.club/new/termos-de-uso/";
            window.open(url, '_system', 'location=yes','closebuttoncaption=back,toolbar=yes');
        }

         /*
         * Troca a view (url) através de elementos
         */
        $scope.changeView = function(view) {    
            console.log(view);
            if(view == '/true')
                $location.path('/profile')
            else if(view == '/false')
                $location.path('/login');

            // Close menu in case of transition            
            if($scope.showMenu == true)
                $scope.setMenuState();

            // Change path
            $location.path(view); // path not hash
        }

        /*
         * sei la o que faz, o Marcao ta no controle do bang aqui parsa
         */
         $scope.redirectToWithSession = function(path) {
            user.token().then(function(response) {
                window.open('https://app.primepass.club/auth/service?token='+response.token+'&redirect_to='+path, '_system', 'location=yes','closebuttoncaption=back,toolbar=yes');
            });
         }
    
        /**
        * Modal material, todas as pagians deverão ser assim
        * por enquanto só planos segue esse conceito
        **/
        $scope.showAdvanced = function(ev,template,type,fullscreen) {
            
            $scope.fullscreen = true;

            console.log(fullscreen);

            if(fullscreen == 'small')
                $scope.fullscreen = false;
            else 
                $scope.fullscreen = true;

            //Fecha um modal e abre outro
            if(type == 'remove')
                $mdDialog.cancel();

            //Esta tela só pode ser
            if(template == 'tela-inicial'){
                var user = JSON.parse(localStorage.getItem("userPrime"));
                if(!user){
                    $location.path('/login')
                }
            }

            $window.ga('send', 'screenview', {
                screenName : template,
                appName    : 'Primepass Mobile'
            });

            $mdDialog.show({
                controller: DialogController,
                templateUrl: 'views/modal/'+template+'.tmpl.html',
                parent: angular.element(document.body),
                targetEvent: ev,
                clickOutsideToClose:true,
                fullscreen: $scope.fullscreen           // Only for -xs, -sm breakpoints.
            })
            .then(function(answer) {
                console.log('foi');
            }, function() {
                console.log('nao foi');
            });        
        };

        function DialogController($scope, $mdDialog, $location) {
            
            $scope.hide = function() {
                $mdDialog.hide();
            };

            $scope.cancel = function() {
                $mdDialog.cancel();
            };

            $scope.answer = function(answer) {
                $mdDialog.hide(answer);
            };

            $scope.sendView = function(view) {                
                $mdDialog.cancel();
                $location.path(view); // path not hash
            }
        } 
    }]);

    // =====================================
    // == TopBar - Barrinha de cima
    // =====================================
    myApp.controller('topBarController', function($scope){
        // Link
        $scope.backTo = '/';
    });

    // =====================================
    // == Página inicial - Welcome
    // c=====================================
    myApp.controller('homeController', ['$scope', '$rootScope','movies','youtubeAPI','$location','cinemas','$base64', 'contato','$filter','$mdToast', '$http','cacheMovies', function($scope, $rootScope,movies,youtubeAPI,$location,cinemas,$base64, $contato,$filter,$mdToast, $http, cacheMovies){
        
        // var moviesUrl = "https://app.primepass.club/mobile/api/movies";

        // $scope.getMovies = function() {
        //     if(cacheMovies.get('teste')) {
        //         console.log('filme consumido da api');
        //         $rootScope.movies = cacheMovies.get('teste').movies;
        //         $rootScope.smovies = cacheMovies.get('teste').movies;
        //     } else {
        //         $http.post('https://app.primepass.club/mobile/api/movies',{'typeof': 'theaters'}).then(function(response){
        //             cacheMovies.put('teste',response.data);
        //             $rootScope.movies = response.data.movies;
        //             $rootScope.smovies = response.data.movies;
        //             console.log('aqui foi cache');
        //         });
        //     }
        // }        

        if($rootScope.online === true ) {
            preLoadType('insert');            
        }

        // zera o filtro de busca por generos
        $rootScope.genreStatus = '';

        //Create contact PrimePass on list celphone at first open             
        if($rootScope.deviceReady){
            if(!localStorage.getItem("celPrime")) {
                $contato.createContact();
            }        
        }        

        // jQuery('.snap-content').css('transform','translate3d(0,0,0)');
        // jQuery('.snap-content').css('overflow','auto');            

        localStorage.removeItem('preload-image');
        
        $scope.name_genre = 'Gêneros'; // para usar como default generos na lista de generos

        $rootScope.hideTopBar = ''; // zera topbar para mostrar sessoes
        

        $scope.openWebSite = function(url) {
            window.open(url, '_system', 'location=no','closebuttoncaption=back');
            // window.open('https://app.primepass.club/auth/service', '_system', 'location=yes','closebuttoncaption=back,toolbar=yes','Authorization:Basic bWljaGVsdGVzdGV6c0Bob3RtYWlsLmNvbToxNTk3NTNNaWhA');
        }

        $scope.saveImageAndSendUrl = function(movie_id, url_image) {
            localStorage.setItem('preload-image',$base64.encode(url_image));
            $location.path('/movie/'+movie_id);           
        }        

        // Lista de filmes        
        $rootScope.movies = [];         

        //filmes

        movies.all('theaters').then(function(response) {            
            preLoadType('remove');

            $rootScope.movies = response.movies;
            $rootScope.smovies = response.movies;
        });

        // banner tela principal

        if(localStorage.getItem('userPrime')) {
            var user = JSON.parse(localStorage.getItem('userPrime'));
            console.log(user);            

            if (user.plan != "empty") {
                console.log('pagante');
                movies.banner('theater').then(function(response){            
                    $scope.imageBanner = response.url;
                    $scope.idBanner = response.movie_id;
                    $scope.typeBanner = 'sign';
                });
            } else {
                console.log('usuario nao pagamente');
                movies.banner('promotion').then(function(response){            
                    $scope.imageBanner = response.url;
                    $scope.urlBanner = response.movie_id;
                    $scope.typeBanner = 'promo';                    
                });
            }
        
        } else {
            console.log('nem ta logado');
            movies.banner('promotion').then(function(response){            
                $scope.imageBanner = response.url;
                $scope.urlBanner = response.movie_id;
                $scope.typeBanner = 'promo';                
            });
        }        

        //state filmes em estreia para mostrar dropdown
        $scope.launchState = function(name){            

            //fechar drop de cinemas caso esteja aberto
            if($scope.showFiltersCinema == 'active')
                $scope.showFiltersCinema = '';

            //fechar drop de generos caso esteja aberto
            if($scope.showGenre == 'active')
                $scope.showGenre = '';

            // verifica se o drop esta aberto, caso esteja, com outro click fecha
            $scope.showLaunch = !$scope.showLaunch ? 'active':'';            

        }

        // filmes em estreia
        $scope.posterMovies = function(name){                                        

            $scope.showFiltersCinema = '';
            $scope.showGenre = '';

            $scope.showLaunch = '';

            $scope.movies2 = $rootScope.movies;            

            if(name == 'Estréias'){
            
                $rootScope.smovies = $filter('filter')($scope.movies2, {is_new:'true'});                              
                
            }else {                
                $rootScope.smovies = $filter('filter')($scope.movies2);
            }         
        }


        // =======================================
        // == Mostra os filtros de cinemas ou
        // == esconde
        // =======================================
        $scope.setFilterCinemaState = function()
        {   
            if($scope.statusCinema != '200'){
                $mdToast.show(
                    $mdToast.simple({
                    textContent :   'Sincronizando lista de cinemas, aguarde mais alguns instantes.',
                    hideDelay   :   3000,
                    position    : 'top left',
                    action      : 'x'                                       
                    }));
            }else{                
                $scope.showFiltersCinema = !$scope.showFiltersCinema ? 'active':'';

                //para nao ficar com outro filtro aberto
                if($scope.showGenre == 'active')
                    $scope.showGenre = '';

                if($scope.showLaunch == 'active') 
                    $scope.showLaunch = '';
            }
        }  

        //mostra ou esconde filtros de generos
        $scope.setFilterGenres = function(){

            //para nao ficar com outro filtro aberto
            if($scope.showFiltersCinema == 'active')
                $scope.showFiltersCinema = '';

            //fechar filtro para nao sobrepor
            if($scope.showLaunch == 'active')
                $scope.showLaunch = '';

            $scope.showGenre = !$scope.showGenre ? 'active':'';

            preLoadType('remove'); 
        }

        //filtros de generos
        $scope.setFilmType = function(genre,genreBR){
                        
                        
            $scope.name_genre = genreBR;        

            // reseta o click         
            $scope.setFilterGenres(genreBR);

            $scope.movies2 = $rootScope.movies;            

            $rootScope.smovies = $filter('filter')($scope.movies2, genre);

            if($rootScope.smovies.length == 0) {
                $rootScope.smovies = $filter('filter')($scope.movies2, '');
                $scope.name_genre = 'Gêneros';    
                $mdToast.show(
                    $mdToast.simple({
                    textContent :   'Nenhum Filme com esse gênero foi encontrado.',
                    hideDelay   :   3000,
                    position    : 'top left',
                    action      : 'x'                                       
                    }));
                }
        }                        
        
          

        // =======================================
        // == Escuta as modificações nos filtros
        // =======================================
        $rootScope.changeCinemaId = function($cinema){

            // Troca o filtro
            $rootScope.filters.cinema = $cinema.id;

            // Trocamos o título do cinema por esse
            $scope.cinemas_name = $cinema.name;
            //alert('Filtro para o cinema: '+ $cinema.name);

            // Fechamos a opt
            $scope.setFilterCinemaState();
        }

        // =======================================
        // == Busca e altera os dados de acordo
        // == com os filtros.
        // =======================================
        $rootScope.getFilms = function()
        {
            // select * from movies where cinema = '$cinema' and genre = '$genres' DESC LIMIT $limit
        }

        // =======================================
        // == Calcula o range entre números
        // == direto na view
        // =======================================
        // Range (utlizado para as estrelas)
        $rootScope.range = function(min, max, step) {            
            step = step || 1;
            var input = [];
            for (var i = min; i <= max; i += step) {
                input.push(i);
            }
            return input;
        }
    }]);

    // =====================================
    // == Detalhes sobre o filme
    // =====================================
    myApp.controller('movieController', ['$scope','$routeParams', '$rootScope', 'maps','$location','$timeout','user','cinemas','movies','$base64','cinemas','$mdToast','$mdDialog', 'contato', function($scope, $routeParams, $rootScope, maps,$location,$timeout,user,cinemas,movies,$base64,cinemas,$mdToast,$mdDialog, $contato){        

        var script = document.createElement('script');

        script.src=  'https://www.youtube.com/iframe_api';

        document.body.appendChild(script);

        // /**
        // * Sessões por cinema
        // */
        cinemas.getPosition(function(pos) {
            movies.session($routeParams.id,pos.coords.latitude,pos.coords.longitude).then(function(sessions) {
                $scope.sessions = sessions;
            });
        });

        // informacoes sobre usuario, se ele estiver logado
        var userInfo = (JSON.parse(localStorage.getItem('userPrime')));

        // esta sessao trabalha com retorno do login, caso o usuario tento ativar um filme sem estar logado
        var statusSession = JSON.parse(sessionStorage.getItem("statusSession"));
        if(statusSession != null) {
            showMessage(statusSession.message,'Filme','Escolher outra sessão');
            sessionStorage.setItem("statusSession",null);
        }

        // =======================================
        // == Calcula o range entre números
        // == direto na view
        // =======================================
        // Range (utlizado para as estrelas)
        $rootScope.range = function(min, max, step) {            
            step = step || 1;
            var input = [];
            for (var i = min; i <= max; i += step) {
                input.push(i);
            }
            return input;
        }

        // verifica se o usuario esta logado, caso nao, o envia para pagina de login
        $scope.removeThisBG = function(){
            $scope.metter = 'inactive';
        }

        // remove spin loading
        // remember this funcking shit, to use $apply, always use together with $timeout
        function removeLoading(){
            $timeout(function(){
                $scope.$apply(function(){
                    $scope.cardspin = 'inactive';
                    $scope.metter   = 'active';
                });
            },100);
        }        

        $scope.verifyDistancePosition = function ( session_id, type, state, hour, movie_name, theater_name, address, lat, lon, premium ){
            
            preLoadType('insert');

            // registra na sessao os dados do filme/sessao escolhida/o
            // independente isso tem que estar sempre antes da funcao de verificacao de login abaixo
            var sessionInformation  = {id:session_id, type:type, hour: hour, name_movie:movie_name, theater_name: theater_name, address: address, latitude: lat, longitude: lon,state:state,premium:premium}
            sessionStorage.setItem("sessionInformation",JSON.stringify(sessionInformation));

            // user no logged, send to login
            if(!userInfo){
                preLoadType('remove');
                $location.path('/login');
            } else {
                cinemas.getPosition(function(pos) {
                    user.status('verify',sessionInformation.id, pos.coords.latitude, pos.coords.longitude).then(function(response){
                        if(response.status == 'danger') {
                            preLoadType('remove');
                            switch(response.code) {

                                case 'NOSIGNATURE':
                                    var confirm = $mdDialog.confirm()
                                        .parent(angular.element(document.querySelector('#popupContainer')))
                                        .clickOutsideToClose(true)                                        
                                        .textContent(response.message)                                    
                                        .ok('conheça')
                                        .cancel('voltar');

                                    $mdDialog.show(confirm).then(function() {
                                        $scope.showAdvanced('','tela-inicial');
                                    }, function() {
                                      console.log('continuar navegando');
                                    });
                                    break;

                                case 'NOT24HOURS':
                                    var confirm = $mdDialog.confirm()
                                            .parent(angular.element(document.querySelector('#popupContainer')))
                                            .clickOutsideToClose(true)                                            
                                            .textContent(response.message)                                    
                                            .ok('meu local')
                                            .cancel('voltar');

                                        $mdDialog.show(confirm).then(function() {
                                            $scope.showAdvanced('','modal-position','','small');
                                        }, function() {
                                          console.log('continuar navegando');
                                        });
                                        break;

                                case 'NO3D':
                                    var confirm = $mdDialog.confirm()
                                        .parent(angular.element(document.querySelector('#popupContainer')))
                                        .clickOutsideToClose(true)                                        
                                        .textContent(response.message)                                    
                                        .ok('quero 3d')
                                        .cancel('voltar');

                                    $mdDialog.show(confirm).then(function() {
                                      $scope.redirectToWithSession('/panel/upgrade/');
                                    }, function() {
                                      console.log('continuar navegando');
                                    });
                                    break;

                                case 'NOWEEKDAY':
                                    var confirm = $mdDialog.confirm()
                                        .parent(angular.element(document.querySelector('#popupContainer')))
                                        .clickOutsideToClose(true)                                        
                                        .textContent(response.message)                                    
                                        .ok('quero')
                                        .cancel('voltar');

                                    $mdDialog.show(confirm).then(function() {
                                      $scope.redirectToWithSession('/panel/upgrade/');                                                                        
                                    }, function() {
                                      console.log('continuar navegando');
                                    });
                                    break;

                                case 'NOVIP':
                                    var confirm = $mdDialog.confirm()
                                        .parent(angular.element(document.querySelector('#popupContainer')))
                                        .clickOutsideToClose(true)                                        
                                        .textContent(response.message)                                    
                                        .ok('quero ser vip')
                                        .cancel('voltar');

                                    $mdDialog.show(confirm).then(function() {
                                      $scope.redirectToWithSession('/panel/upgrade/');                                                                        
                                    }, function() {
                                      console.log('continuar navegando');
                                    });
                                    break;

                                case 'NOSPECIAL':
                                    var confirm = $mdDialog.confirm()
                                        .parent(angular.element(document.querySelector('#popupContainer')))
                                        .clickOutsideToClose(true)                                        
                                        .textContent(response.message)                                    
                                        .ok('quero ser especial')
                                        .cancel('voltar');

                                    $mdDialog.show(confirm).then(function() {
                                      $scope.redirectToWithSession('/panel/upgrade/');
                                    }, function() {
                                      console.log('continuar navegando');
                                    });
                                    break;

                                    case 'NOCARD':
                                    var confirm = $mdDialog.confirm()
                                        .parent(angular.element(document.querySelector('#popupContainer')))
                                        .clickOutsideToClose(true)                                        
                                        .textContent(response.message)                                    
                                        .ok('ativar')
                                        .cancel('voltar');

                                    $mdDialog.show(confirm).then(function() {
                                      $location.path('/desbloquear');                                     
                                    }, function() {
                                      console.log('continuar navegando');
                                    });
                                    break;

                                default:                            
                                    $mdDialog.show(
                                        $mdDialog.alert()
                                        .parent(angular.element(document.querySelector('#popupContainer')))
                                        .clickOutsideToClose(true)                                        
                                        .textContent(response.message)                                    
                                        .ok('ok')
                                    );                                    
                            }
                        } else if(response.status == 'success') {
                            preLoadType('remove');
                            window.location = '#/card/' + sessionInformation.id;                            
                        } else {
                            sessionStorage.setItem("movieID","/movie/"+$routeParams.id);
                            preLoadType('remove');
                            var confirm = $mdDialog.confirm()
                                .parent(angular.element(document.querySelector('#popupContainer')))
                                .clickOutsideToClose(true)
                                .title('Erro')
                                .textContent('Ocorreu um erro em sua conexão.')                                   
                                .ok('atualizar')
                                .cancel('voltar');

                            $mdDialog.show(confirm).then(function() {
                                $location.path('/leave');
                            }, function() {
                              console.log('continuar navegando');
                            });                            
                        }
                    });
                });                                   
            }                    
        }
       
        // =======================================
        // == Mostra o video ou
        // == esconde
        // =======================================        
        $scope.showMovie = false;
        $scope.setShowMovie = function(){
            $scope.showMovie = !$scope.showMovie ? true:false;
        }
 
        /*
        * REST OF CODE
        */
        var splited;                    
        $scope.id = $routeParams.id;
        movies.shows($scope.id).then(function(response){                        
            $scope.name     = response.name;
            //$scope.rating   = 4;
            $scope.poster   = response.default_image;
            $scope.director = response.director;
            $scope.actors   = response.cast;
            $scope.tags     = response.category;
            $scope.duration = response.duration;
            $scope.description = response.description;
            $scope.age = response.recommended_age;
            $scope.default_image = response.default_image;           
            $scope.rating = response.rating;
            $scope.image_1 = response.image_1;
            // splita url video to get only video id
            var video = response.video_url;
            splited = video.split("=")[1];
            // load youtube player            
            $scope.theBestVideo = splited;
            $scope.step = 'loaded';                               
 
        });

        // controls youtube embed
        $scope.playerVars = {
            controls: 0,
            autohide: 1,
            playsinline: 1,
            start: '01',            
        };

        // catch moment youtube ready
        $scope.$on('youtube.player.ready', function ($event, player) {
            player.playVideo();                
            player.setVolume(100);
        });

        $scope.changeStatmentVideo = function() {            
            $scope.videoTeste = 'clicked';            
        }
        
    }]);

    myApp.controller('soonController',['$scope','$rootScope','movies', function($scope,$rootScope,movies){
        
        // jQuery('.snap-content').css('transform','translate3d(0,0,0)');
        // jQuery('.snap-content').css('overflow','auto');
       // spinner loading para carregar filmes
       // $scope.content__spin = 'active';
       preLoadType('insert');

       // retira titulo de escolha de sessao
       $rootScope.hideTopBar = 'inactive';

       // banner tela principal
       
        movies.banner('soon').then(function(response){
            $scope.imageBannerSoon = response.url;
            $scope.idBannerSoon = response.movie_id;            
        });
        
        //Lista de filmes em breve
        $rootScope.soonMovies = [];
        
       //filmes em breve
       movies.all('soon').then(function(response){
        console.log(response);
        preLoadType('remove');
            $rootScope.soonMovies = response.movies; 
                        
        });
    }]);

    // =====================================
    // == Menu - sidebar
    // =====================================
    myApp.controller('menuController', function($scope){     
    });

    // =====================================
    // == Login
    // =====================================
    myApp.controller('loginController',['$scope','$rootScope','$location','user','movies','$base64','cinemas','$location','$mdDialog','contato', function($scope,$rootScope,$location,user,movies,$base64,cinemas,$location, $mdDialog, $contato){
                    
        // informacoes sobre o device
        var device = JSON.parse(localStorage.getItem('deviceInfo'));

        $scope.openForgotPasswordLink = function () {            
            window.open('http://app.primepass.club/recuperar-senha', '_system', 'location=no','closebuttoncaption=back');            
        }
        
        $scope.logoutFacebook = function(){            
            cordova.plugins.Keyboard.close();
            var fblogoutSuccess = function(userData){
                console.log(userData);
            }

            facebookConnectPlugin.logout(
                fblogoutSuccess, 
                function (response){
                });
        }

        $scope.checkLogin = function(type) {            
            if(device.platform != 'iOS')
               preLoadType('insert','Login','Aguarde enquanto sincronizamos sua conta com nosso servidor.');
           else              
              preLoadType('insert',null,'Sincronizando conta');

            if(type == 'normal') {
                //email login
                if($scope.email != '' && $scope.senha != '') {                    
                    localStorage.setItem("auth","Basic "+$base64.encode($scope.email+':'+$scope.senha));
                    user.login($scope.email,$scope.senha, device.model, device.platform, device.device_uuid, 'normal').then(function(response) {
                        console.log(response.code);
                        if(response.status == 'success') { // se der sucesso, loga o usuario
                            preLoadType('remove');
                            //seta infos do user na sessao local
                            localStorage.setItem("userPrime",JSON.stringify(response.data));
                            
                            //variaveis globais para mostrar menu logado e image user se houver
                            $rootScope.is_log    = 'true'; // seta menu para mostrar que esta logado
                            $rootScope.imageUser = response.data.picture; // imagem do usuario
                            $rootScope.cardact   = response.data.card_prime_ID;
                            $rootScope.name__user    = response.data.name+' '+response.data.middlename;
                            localStorage.setItem("newLogin",true);


                            // agora precisa da info do user e se houver sessao ele continua
                            var userInfo = JSON.parse(localStorage.getItem('userPrime'));
                            var sessionInfo = JSON.parse(sessionStorage.getItem("sessionInformation"));
                            console.log(sessionInfo);
                            // duas vertentes, se houver sessao e se nao houver
                            if(sessionInfo == null) {
                                // mada usuario para tela de perfil
                                $location.path('/profile');
                            } else {
                                                        
                                cinemas.getPosition(function(pos) {
                                    user.status('verify',sessionInfo.id, pos.coords.latitude, pos.coords.longitude).then(function(response){
                                        if(response.status == 'danger') {
                                            preLoadType('remove');
                                            switch(response.code) {

                                                case 'NOSIGNATURE':
                                                    var confirm = $mdDialog.confirm()
                                                        .parent(angular.element(document.querySelector('#popupContainer')))
                                                        .clickOutsideToClose(true)                                        
                                                        .textContent(response.message)                                    
                                                        .ok('conheça')
                                                        .cancel('voltar');

                                                    $mdDialog.show(confirm).then(function() {
                                                        $scope.showAdvanced('','tela-inicial');
                                                    }, function() {
                                                      console.log('continuar navegando');
                                                    });
                                                    break;

                                                case 'NOT24HOURS':
                                                    var confirm = $mdDialog.confirm()
                                                            .parent(angular.element(document.querySelector('#popupContainer')))
                                                            .clickOutsideToClose(true)                                            
                                                            .textContent(response.message)                                    
                                                            .ok('meu local')
                                                            .cancel('voltar');

                                                        $mdDialog.show(confirm).then(function() {
                                                            $scope.showAdvanced('','modal-position','','small');
                                                        }, function() {
                                                          console.log('continuar navegando');
                                                        });
                                                        break;

                                                case 'NO3D':
                                                    var confirm = $mdDialog.confirm()
                                                        .parent(angular.element(document.querySelector('#popupContainer')))
                                                        .clickOutsideToClose(true)                                                        
                                                        .textContent(response.message)                                    
                                                        .ok('quero 3d')
                                                        .cancel('voltar');

                                                    $mdDialog.show(confirm).then(function() {
                                                      $scope.redirectToWithSession('/panel/upgrade/');
                                                    }, function() {
                                                      console.log('continuar navegando');
                                                    });
                                                    break;

                                                case 'NOWEEKDAY':
                                                    var confirm = $mdDialog.confirm()
                                                        .parent(angular.element(document.querySelector('#popupContainer')))
                                                        .clickOutsideToClose(true)                                                        
                                                        .textContent(response.message)                                    
                                                        .ok('quero')
                                                        .cancel('voltar');

                                                    $mdDialog.show(confirm).then(function() {
                                                      $scope.redirectToWithSession('/panel/upgrade/');                                                                        
                                                    }, function() {
                                                      console.log('continuar navegando');
                                                    });
                                                    break;

                                                case 'NOVIP':
                                                    var confirm = $mdDialog.confirm()
                                                        .parent(angular.element(document.querySelector('#popupContainer')))
                                                        .clickOutsideToClose(true)                                        
                                                        .textContent(response.message)                                    
                                                        .ok('quero ser vip')
                                                        .cancel('voltar');

                                                    $mdDialog.show(confirm).then(function() {
                                                      $scope.redirectToWithSession('/panel/upgrade/');                                                                        
                                                    }, function() {
                                                      console.log('continuar navegando');
                                                    });
                                                    break;

                                                case 'NOSPECIAL':
                                                    var confirm = $mdDialog.confirm()
                                                        .parent(angular.element(document.querySelector('#popupContainer')))
                                                        .clickOutsideToClose(true)                                        
                                                        .textContent(response.message)                                    
                                                        .ok('quero ser especial')
                                                        .cancel('voltar');

                                                    $mdDialog.show(confirm).then(function() {
                                                      $scope.redirectToWithSession('/panel/upgrade/');
                                                    }, function() {
                                                      console.log('continuar navegando');
                                                    });
                                                    break;

                                                    case 'NOCARD':
                                                    var confirm = $mdDialog.confirm()
                                                        .parent(angular.element(document.querySelector('#popupContainer')))
                                                        .clickOutsideToClose(true)                                        
                                                        .textContent(response.message)                                    
                                                        .ok('ativar')
                                                        .cancel('voltar');

                                                    $mdDialog.show(confirm).then(function() {
                                                      $location.path('/desbloquear');                                     
                                                    }, function() {
                                                      console.log('continuar navegando');
                                                    });
                                                    break;

                                                default:                            
                                                    $mdDialog.show(
                                                        $mdDialog.alert()
                                                        .parent(angular.element(document.querySelector('#popupContainer')))
                                                        .clickOutsideToClose(true)                                        
                                                        .textContent(response.message)                                    
                                                        .ok('ok')
                                                    );                                    
                                            }
                                            window.history.back();
                                        } else {
                                            preLoadType('remove');
                                            window.location = '#/card/' + sessionInfo.id;    
                                        }
                                    });
                                });                                   
                            }

                        } else if(response.status == 'danger') {// se o email nao existe avisa o usuario( default undefined)                            
                            
                            preLoadType('remove');
                            localStorage.removeItem('auth');

                            if(response.code == 'mobileError') {
                                console.log('aqui');                                
                                var confirm = $mdDialog.confirm()
                                    .parent(angular.element(document.querySelector('#popupContainer')))
                                    .clickOutsideToClose(true)                                    
                                    .textContent(response.message)                                    
                                    .ok('ajuda')
                                    .cancel('voltar');

                                $mdDialog.show(confirm).then(function() {
                                    $contato.openWhatSapp();
                                }, function() {
                                  console.log('continuar navegando');
                                });
                            } else {
                                console.log('error');
                                $mdDialog.show(
                                    $mdDialog.alert()
                                    .parent(angular.element(document.querySelector('#popupContainer')))
                                    .clickOutsideToClose(true)                                
                                    .textContent(response.message)                                    
                                    .ok('ok')
                                );
                            }
                             
                        } else { // se o email nao existe avisa o usuario( default undefined)                                                    
                            preLoadType('remove');
                            localStorage.removeItem('auth');                            
                            $mdDialog.show(
                                $mdDialog.alert()
                                .parent(angular.element(document.querySelector('#popupContainer')))
                                .clickOutsideToClose(true)                                
                                .textContent(response.message)                                    
                                .ok('ok')
                            ); 
                        }
                    });
                } else { // se os campos estiverem vazios                    
                    preLoadType('remove');
                    $mdDialog.show(
                        $mdDialog.alert()
                        .parent(angular.element(document.querySelector('#popupContainer')))
                        .clickOutsideToClose(true)                        
                        .textContent('Preencha todos os campos e acesse ao mundo do Cinema Ilimitado.')                                    
                        .ok('ok')
                    );                     
                }
            }else{
                // facebook login                
                var fbLoginSuccess = function (userData) {                    
                    var device = JSON.parse(localStorage.getItem('deviceInfo'));
                    facebookConnectPlugin.api("me/?fields=id,email,first_name,last_name,picture.type(large)", null,
                        function (response) {
                            localStorage.setItem("auth","Basic "+$base64.encode(response.email+':'+response.id));
                            facebookConnectPlugin.api("me/permissions/publish_actions",null,
                                function(permission){
                                    console.log(permission);
                                },
                                function(error){
                                    console.log(error);
                                }
                            );
                            user.loginFB(response.first_name, response.last_name, response.id, response.picture.data.url, response.email, userData.authResponse.accessToken, device.model, device.platform, device.device_uuid, 'facebook')                            
                            .then(function(userResponse) {                                

                                if(userResponse.status == 'success') {
                                    //make auth login facebook                                     

                                    localStorage.setItem("userPrime",JSON.stringify(userResponse.data));
                                    // localStorage.setItem("secretKey",response.secret_key);
                                    
                                    //active user_id on access_token
                                    // movies.banner('theater');                                                        
                                    
                                    // agora precisa da info do user e se houver sessao ele continua
                                    var userInfo = JSON.parse(localStorage.getItem('userPrime'));
                                    var sessionInfo = JSON.parse(sessionStorage.getItem("sessionInformation"));

                                    // variaveis global para mostrar menu logado e image user se houver
                                        $rootScope.is_log    = 'true'; // seta menu para mostrar que esta logado
                                        $rootScope.imageUser = userResponse.data.picture; // imagem do usuario(default undefined)
                                        $rootScope.cardact   = userResponse.data.card_prime_ID;
                                        $rootScope.name__user    = userResponse.data.name+' '+userResponse.data.middlename;
                                        localStorage.setItem("newLogin",true);
                                    
                                    // duas vertentes, se houver sessao e se nao houver
                                    if(sessionInfo == null) {

                                        // movies.banner('theater');                                    
                                        // mada usuario para tela de perfil
                                        preLoadType('remove');

                                        //manda usuario para tela de profile
                                        $location.path('/profile');

                                    } else {
                                        cinemas.getPosition(function(pos) {
                                            user.status('verify',sessionInfo.id, pos.coords.latitude, pos.coords.longitude).then(function(response){
                                                if(response.status == 'danger'){
                                                    preLoadType('remove');
                                                    switch(response.code) {

                                                        case 'NOSIGNATURE':
                                                            var confirm = $mdDialog.confirm()
                                                                .parent(angular.element(document.querySelector('#popupContainer')))
                                                                .clickOutsideToClose(true)                                        
                                                                .textContent(response.message)                                    
                                                                .ok('conheça')
                                                                .cancel('voltar');

                                                            $mdDialog.show(confirm).then(function() {
                                                                $scope.showAdvanced('','tela-inicial');
                                                            }, function() {
                                                              console.log('continuar navegando');
                                                            });
                                                            break;

                                                        case 'NOT24HOURS':
                                                            var confirm = $mdDialog.confirm()
                                                                    .parent(angular.element(document.querySelector('#popupContainer')))
                                                                    .clickOutsideToClose(true)                                            
                                                                    .textContent(response.message)                                    
                                                                    .ok('meu local')
                                                                    .cancel('voltar');

                                                                $mdDialog.show(confirm).then(function() {
                                                                    $scope.showAdvanced('','modal-position','','small');
                                                                }, function() {
                                                                  console.log('continuar navegando');
                                                                });
                                                                break;

                                                        case 'NO3D':
                                                            var confirm = $mdDialog.confirm()
                                                                .parent(angular.element(document.querySelector('#popupContainer')))
                                                                .clickOutsideToClose(true)
                                                                .title('Sessão')
                                                                .textContent(response.message)                                    
                                                                .ok('quero 3d')
                                                                .cancel('voltar');

                                                            $mdDialog.show(confirm).then(function() {
                                                              $scope.redirectToWithSession('/panel/upgrade/');
                                                            }, function() {
                                                              console.log('continuar navegando');
                                                            });
                                                            break;

                                                        case 'NOWEEKDAY':
                                                            var confirm = $mdDialog.confirm()
                                                                .parent(angular.element(document.querySelector('#popupContainer')))
                                                                .clickOutsideToClose(true)
                                                                .title('Sessão')
                                                                .textContent(response.message)                                    
                                                                .ok('quero')
                                                                .cancel('voltar');

                                                            $mdDialog.show(confirm).then(function() {
                                                              $scope.redirectToWithSession('/panel/upgrade/');                                                                        
                                                            }, function() {
                                                              console.log('continuar navegando');
                                                            });
                                                            break;

                                                        case 'NOVIP':
                                                            var confirm = $mdDialog.confirm()
                                                                .parent(angular.element(document.querySelector('#popupContainer')))
                                                                .clickOutsideToClose(true)                                        
                                                                .textContent(response.message)                                    
                                                                .ok('quero ser vip')
                                                                .cancel('voltar');

                                                            $mdDialog.show(confirm).then(function() {
                                                              $scope.redirectToWithSession('/panel/upgrade/');                                                                        
                                                            }, function() {
                                                              console.log('continuar navegando');
                                                            });
                                                            break;

                                                        case 'NOSPECIAL':
                                                            var confirm = $mdDialog.confirm()
                                                                .parent(angular.element(document.querySelector('#popupContainer')))
                                                                .clickOutsideToClose(true)                                        
                                                                .textContent(response.message)                                    
                                                                .ok('quero ser especial')
                                                                .cancel('voltar');

                                                            $mdDialog.show(confirm).then(function() {
                                                              $scope.redirectToWithSession('/panel/upgrade/');
                                                            }, function() {
                                                              console.log('continuar navegando');
                                                            });
                                                            break;

                                                            case 'NOCARD':
                                                            var confirm = $mdDialog.confirm()
                                                                .parent(angular.element(document.querySelector('#popupContainer')))
                                                                .clickOutsideToClose(true)                                        
                                                                .textContent(response.message)                                    
                                                                .ok('ativar')
                                                                .cancel('voltar');

                                                            $mdDialog.show(confirm).then(function() {
                                                              $location.path('/desbloquear');                                     
                                                            }, function() {
                                                              console.log('continuar navegando');
                                                            });
                                                            break;

                                                        default:                            
                                                            $mdDialog.show(
                                                                $mdDialog.alert()
                                                                .parent(angular.element(document.querySelector('#popupContainer')))
                                                                .clickOutsideToClose(true)                                        
                                                                .textContent(response.message)                                    
                                                                .ok('ok')
                                                            );                                    
                                                    }
                                                    window.history.back();
                                                } else {
                                                    preLoadType('remove');
                                                    window.location = '#/card/' + sessionInfo.id;    
                                                }
                                            });
                                        }); 
                                    }
                                } else {                                    
                                    preLoadType('remove');
                                    localStorage.removeItem('auth');
                                     $mdDialog.show(
                                        $mdDialog.alert()
                                        .parent(angular.element(document.querySelector('#popupContainer')))
                                        .clickOutsideToClose(true)
                                        .title('Sessão')
                                        .textContent(userResponse.message)                                    
                                        .ok('ok')
                                    );
                                    $location.path('/login');
                                    return;
                                }                                                               
                            });
                    },function (response) { console.log(JSON.stringify(response)); alert('error'); }); 
                }

                //login facebook normal
                facebookConnectPlugin.login(["public_profile","email"],
                fbLoginSuccess,
                function (error) {
                    preLoadType('remove');
                     $mdDialog.show(
                        $mdDialog.alert()
                        .parent(angular.element(document.querySelector('#popupContainer')))
                        .clickOutsideToClose(true)
                        .title('Sessão')
                        .textContent('Você cancelou a sincronização com a conta do facebook.')
                        .ok('ok')
                    );
                }
                );
            }  
        }
    }]);

    // =====================================
    // == cardController - View do card
    // =====================================
    myApp.controller("cardController",['$scope','$routeParams','$location','card','maps','user','$rootScope','$timeout','accentivHander','cinemas','$mdDialog', function($scope, $routeParams,$location,card,maps,user,$rootScope,$timeout,accentivHander,cinemas, $mdDialog){
        
        $scope.cardspin = 'inactive';

        //infos sobre user        
        var userInfo = JSON.parse(localStorage.getItem('userPrime'));


        // accentivHander.sendEmail('302','1259');

        //infos sobre a sessao e o cinema
        // essas infos sao trocadas cada vez que clica e sao resetadas ao fechar o app
        var sessionInformation = JSON.parse(sessionStorage.getItem('sessionInformation'));
        console.log(sessionInformation.id);
        // console.log(session);
        //console.log(session);
        $scope.movie_name = sessionInformation.name_movie;
        $scope.hour_session = sessionInformation.hour;
        $scope.type_session = sessionInformation.type;
        $scope.theater_name = sessionInformation.theater_name;

        // remove distance bg
        $scope.removeThisBG = function(){
            $scope.metter = 'inactive';
        }

        // remove spin loading
        // remember this funcking shit, to use $apply, always use together with $timeout
            function removeLoading(){
                $timeout(function(){
                    $scope.$apply(function(){
                        $scope.cardspin = 'inactive';
                        $scope.metter   = 'active';
                    });
                },100);
            } 

        
        // verifica se o usuario está logado ou não
        // se estiver manda pra paginad e sucesso(informação estática)
        $scope.verifyDistance = function(){            
            preLoadType('insert'); //depois vejo isso            
                 
            // passing theater position and get user positions, do calc distance between them
            cinemas.getPosition(function(pos) {
                user.status('charge',sessionInformation.id, pos.coords.latitude, pos.coords.longitude).then(function(response){
                    if(response.status == 'danger') {
                        preLoadType('remove');
                        showMessage(response.message,'Erro','');
                    } else if(response.status == 'success') {
                        preLoadType('remove');
                        if ( (response.type !== undefined) && (response.type == 'redeem_code')) {
                            localStorage.setItem('cupom', JSON.stringify(response));
                            $location.path('/cupom/'+response.network_id);
                        } else {
                            $location.path('/passe');
                        }
                    } else  {
                        preLoadType('remove');
                        var confirm = $mdDialog.confirm()
                            .parent(angular.element(document.querySelector('#popupContainer')))
                            .clickOutsideToClose(true)
                            .title('Sessão')
                            .textContent('Ocorreu um erro em sua conexão.')                                   
                            .ok('atualizar')
                            .cancel('voltar');

                        $mdDialog.show(confirm).then(function() {
                            $location.path('/leave');
                        }, function() {
                          console.log('continuar navegando');
                        });
                    }
                });
            });  
        }
    }]);

    // =================ec====================
    // == cardSuccessController - View do card (sucesso)
    // =====================================
    myApp.controller("cardSuccessController", function($scope, $routeParams,$location){
        
    });
    // =====================================
    // == cinemas listado em order crescente
    // == de acordo com a geoposition do usuario
    // =====================================
    myApp.controller("cinemaController",['$scope','cinemas','$timeout','$rootScope','$location','$anchorScroll', function($scope,cinemas,$timeout,$rootScope,$location,$anchorScroll){
                
        var script = document.createElement('script');

        script.src=  'http://maps.googleapis.com/maps/api/js?key=AIzaSyCqiTAwq91eg0w2cCKwu3WJeyY1EpJ5aSI&libraries=geometry';

        document.body.appendChild(script);                

        var device = JSON.parse(localStorage.getItem('deviceInfo'));

        $scope.activeList = 'active';
        $rootScope.activeMap =  'false';

        if(device.platform != 'iOS')     
            preLoadType('insert','Localização','Aguarde enquanto verificamos os cinemas mais próximos de você.');
        else          
          preLoadType('insert','Localização','Atualizando Cinemas');

        $scope.changeViewCinema = function(type) {
            if(type == 'go') {
                $rootScope.activeMapView = 'active';
                $scope.activeMap = 'active';
                $scope.activeList = 'false';                
                $('.slick-slider').slick('slickNext');
            } else {
                $rootScope.activeMapView = 'false';
                $scope.activeMap = 'false';                
                $scope.activeList = 'active';                
                $('.slick-slider').slick('slickPrev');
            }
        }

        cinemas.getPosition(function (pos){
            cinemas.getList(pos.coords.latitude, pos.coords.longitude).then(function(response){
                
                $scope.cinemas = response.data;
                var locations  = response.data;                
                preLoadType('remove');

            /*
            * Monta mapa dinamico
            * de acordo com geoposition do usuario
            */
            cinemas.getPosition(function(pos) {
                var map = new google.maps.Map(document.getElementById('new-map'), {
                    zoom: 13,
                    center: new google.maps.LatLng(pos.coords.latitude, pos.coords.longitude),
                    mapTypeId: google.maps.MapTypeId.ROADMAP,
                    disableDefaultUI: true     
                });

                google.maps.event.addListener(map,'tilesloaded',function(){
                    });
                
                var userPos = {
                    lat: pos.coords.latitude,
                    lng: pos.coords.longitude,
                }

                // var userImage = 'https://app.primepass.club/assets/mobile/position.png';

                var testeImage = 'img/maps/pin_local.png';

                var testePinNeutro = 'img/maps/default_rounded.png';

                var testePinActive = 'img/maps/Primeweb-pin.png';

                var userMarker = new google.maps.Marker({
                    position: new google.maps.LatLng(userPos),
                    map: map,
                    icon: testeImage                    
                });      

                var infowindow = new google.maps.InfoWindow();
                google.maps.event.addListener(userMarker,'click',(function(userMarker) {
                    return  function() {
                        infowindow.setContent('Localização Atual');
                        infowindow.open(map,userMarker);
                    }
                }) (userMarker));


                var marker, i, currentInfoMarker;
                var image = 'https://app.primepass.club/assets/mobile/spin.png';

                for (i = 0; i < locations.length; i++) {

                    //variavel de pin redondo
                    var defaultPin = locations[i].pin_image == "" ? "img/maps/default_rounded.png":'img/maps/'+locations[i].pin_image+'_rounded.png';                    
                    // marker default baseado na rede do cinema                    
                    marker = new google.maps.Marker({
                    position: new google.maps.LatLng(locations[i].latitude, locations[i].longitude),
                    map: map,
                    icon: defaultPin
                });              

                //evento que dispara quando alguém clica no pin
                google.maps.event.addListener(marker, 'click', (function(marker, i) {                                                    
                    
                    var activePin = locations[i].pin_image == "" ? "img/maps/Primeweb-pin.png":'img/maps/'+locations[i].pin_image+'.png';                    
                    
                    return function() {
                        //fecha pin aberto se houver e volta o icone antigo    
                        if($scope.info == 'true') {                            
                            var pinToClose = $scope.rede == "" ? "img/maps/default_rounded.png":'img/maps/'+$scope.rede+'_rounded.png';                                                            
                            marker.setIcon(pinToClose);
                            currentInfoMarker.setIcon(pinToClose);
                            infowindow.close();
                        }

                        infowindow.setContent(
                        "<div class='content-infowindow'>"+
                            "<b>"+locations[i].monetized_name+"</b>"+"<br />"+
                            "<div class='endereco-cinema'>"+locations[i].address+
                            "</div>"+
                            "<a href='#/moviesByCinema/"+locations[i].id+"'>"+
                            "<p>ver filmes em cartaz</p>"+
                            "<i class='fa fa-angle-right' aria-hidden='true></i>"+
                            "</a>"+
                        "</div>"
                        );
                        infowindow.setOptions({maxWidth:200});
                        infowindow.open(map, this);
                        currentInfoMarker = this;
                        marker.setIcon(activePin);
                        $scope.rede =  locations[i].pin_image;
                        $scope.info = 'true';
                        console.log($scope.info);
                        console.log($scope.rede);
                    }
                  }) (marker, i));

                // evento que dispara quando alguém fecha o pin
                google.maps.event.addListener(infowindow,'closeclick',function(marker) {                    
                    var pinToClose = $scope.rede == "" ? "img/maps/default_rounded.png":'img/maps/'+$scope.rede+'_rounded.png';                                        
                    currentInfoMarker.setIcon(pinToClose);
                    $scope.info = 'false';
                    // then, remove the infowindows name from the array
                });

                google.maps.event.addListener(map, 'click', function() {
                    var pinToClose = $scope.rede == "" ? "img/maps/default_rounded.png":'img/maps/'+$scope.rede+'_rounded.png';
                    marker.setIcon(pinToClose);
                    infowindow.close();
                });

                }

                });
            }); 
        });     
    }]);

    // =====================================
    // == only make tests
    // =====================================
    myApp.controller("exampleController",['$scope','youtubeAPI','$location',function($scope,youtubeAPI,$location){
        
    }]);    

    // =====================================
    // == logout and send to index.html asdsad
    // =====================================
    myApp.controller("leaveController",['$scope','$location','$rootScope','$http','user', function($scope,$location,$rootScope,$http,user){
        $rootScope.is_log = 'false';
        $rootScope.name__user    = 'Login';
        $rootScope.imageUser = '';
        localStorage.removeItem("userPrime"); //zera info usuario
        sessionStorage.removeItem("sessionInformation"); //zera informacoes de outras sessoes sobre filme        
        localStorage.removeItem("auth");
        facebookConnectPlugin.logout(); // logout facebook                
        $location.path('/login');
    }]);

    // =====================================
    // == logout and send to index.html
    // =====================================
    myApp.controller("profileController",['$scope','$location','$http', function($scope,$location,$http){
        
        // $http.get("http://-primepass-dev-laravel-mfbasso737064.codeanyapp.com/public/mobile/api/teste/sign")
        // .then(function(response){
        //     alert(JSON.stringify(response.data));
        // });

        var user = JSON.parse(localStorage.getItem("userPrime"));
        if(!user){
            $location.path('/login')
        }
        $scope.name = user.name;
        $scope.lastName = user.middlename;
        $scope.email = user.email;
        $scope.planName = user.plan == 'empty' ? 'Sem assinatura':user.plan.name; 

    }]);   

    //controller Modal
    myApp.controller("modalController",['$scope','card', '$timeout', '$rootScope','user', function($scope, card, $timeout, $rootScope,user){
        $scope.status__card = 'Desbloquear Cartão';
        $scope.btnStatusClass = '';
        $scope.cardspinner = 'inactive';
        $scope.answer_request = 'inactive';

        //funcao para desativar toda parada de resposta negativa e tals
        $scope.setAnswerState = function(){
            $scope.answer_request = 'inactive';
        }

        $scope.activeCard = function() {

            var userInfo = JSON.parse(localStorage.getItem("userPrime"));        
            console.log(userInfo);

            $scope.cardspinner = '';
            console.log($scope.status__card);            

            $timeout(function(){
                // Faz a requisiçao ajax
                card.active($scope.card_number,userInfo.id).then(function(response){
                    // check for success
                    if(response.success == 'true') {
                        user.dataUser(userInfo.id).then(function(response){
                            localStorage.setItem("userPrime",JSON.stringify(response));
                            $rootScope.cardact = response.card_prime_ID;
                        });
                        // Ativa e faz os efeitos                    
                        console.log('Ativado com sucesso');                    
                        $scope.cardspinner = 'inactive';
                        $scope.boxModal = 'inactive';
                        $scope.status__card = 'Cartão desbloqueado com sucesso.';
                        $scope.updown = 'up';


                        // Timeout para executar isso
                        $timeout(function(){
                            $rootScope.setModalState();
                            $scope.modalUnblock = '';
                            $scope.updown = '';
                            $scope.status__card = 'Desbloquear cartão';
                        }, 4000)

                    } else {
                        $rootScope.setModalState();
                        $scope.cardspinner = 'inactive';
                        $scope.answer_request = '';
                        $scope.answer_card = response.message;                    
                    }
                });    
            },100)           
        }
    }]); 

     //controller Modal de Ticket
    myApp.controller("modalTicketController",['$scope','user','$location',function($scope,user,$location){        
        $scope.cardspinticket = 'inactive';
        $scope.response       = 'inactive';        

        $scope.sendTicket = function(info){
            $scope.cardspinticket = 'active';

            var user = JSON.parse(localStorage.getItem("userPrime"));
            //console.log(info.message);
            user.ticket(user.name, user.middlename,user.email,info.message).then(function(response){                
                $scope.cardspinticket = 'active';
                if(response.status == 'success'){
                    $scope.cardspinticket = 'inactive';                    
                    $scope.response       = 'active';
                    $scope.answer__response = 'active';
                    $scope.modalTicket  = !$scope.modalTicket ? 'active':'';
                    $scope.answer = 'Ticket enviado com sucesso. Em breve entraremos em contato.';                 
                }else{
                    $scope.cardspinticket = 'inactive';                                        
                    $scope.response        = 'active';
                    $scope.answer__response = 'active';
                    $scope.modalTicket  = !$scope.modalTicket ? 'active':''; 
                    $scope.answer = 'Houve um erro ao enviar seu ticket. Por favor, verifique se está logado, ou se digitou corretamente a mensagem.';
                }                
            });
        }

        $scope.eraseAll = function() {                    
            $scope.response       = 'inactive';
            $scope.answer__response = 'inactive';
                                
        }
    }]);    

    //controller terms
    myApp.controller("termsController",['$scope', '$location', function($scope, $location){            

    }]);  

    //controller politics
    myApp.controller("politicsController",['$scope',function($scope){

    }]);  

    //controller help
    myApp.controller("helpController",['$scope', '$window', '$location', '$timeout', 'contato', function($scope, $window, $location, $timeout, $contato){
        
        //Criar um contato primepass, se caso nao existir
        $contato.createContact();

        // abre url com intent navegador
        $scope.openWebSite = function(url) {
            // window.open(url, '_self', 'location=no','closebuttoncaption=back');
            window.open(url, '_system', 'location=yes','closebuttoncaption=back,toolbar=yes');
        }
        //abre whatsapp com contato da primepass
        $scope.openWhats = function() {
            $contato.openWhatSapp();
        }

        var _user = JSON.parse(localStorage.getItem("userPrime"));
        $scope.user = _user.plan.id ? "assinante":"sem assinatura";        
              
    }]);

    myApp.controller("historyController",['$scope', '$location', 'user', '$timeout', 'contato',function($scope, $location, user, $timeout, $cordova){

        preLoadType('insert');

        $scope.isCupomInStorage = (localStorage.getItem('cupom') === null) ? false : true;        
        $scope.cupomData = JSON.parse(localStorage.getItem('cupom'));

        $scope.cupomData = JSON.parse(localStorage.getItem('cupom'));

        var user_id = JSON.parse(localStorage.getItem('userPrime')).id;        
        
        user.history(user_id).then(function(response){            
            preLoadType('remove');
            if(response.status == 'error'){
                document.addEventListener("deviceready", onDeviceReady, true);
                function onDeviceReady() {
                    navigator.notification.alert('Você ainda não assistiu nenhum filme.', function(){
                        $timeout(function() {
                            if(x == 1) return; // serve para inibir double warn
                            var x = x+1;
                            $location.path('/');
                        }, 100);
                    }, "Histórico", "");
                }
                return;            
            }
            else{                
                $scope.historicos = response;
            }
        });  
    }]);

    myApp.controller("moviesByCinemaListController",['$scope','$routeParams','movies','$timeout','$location','user','cinemas','$mdToast','$mdDialog','$rootScope', 'contato', '$controller', function($scope,$routeParams,movies,$timeout,$location,user,cinemas,$mdToast, $mdDialog, $rootScope, $contato, $controller){        

        preLoadType('insert');

        $scope.seePlans = '1';        

        // sessoes por cinema
        movies.moviesCinema($routeParams.id).then(function(response) {
            $scope.movies = response.movies;
            preLoadType('remove');

            var statusSession = JSON.parse(sessionStorage.getItem("statusSession"));
            // esta sessao trabalha com retorno do login, caso o usuario tento ativar um filme sem estar logado                  
            if(statusSession != null){
                showMessage(statusSession.message,'Filme','Escolher outra sessão');
                sessionStorage.setItem("statusSession",null);
            }

            // nome do cinema            
            $scope.cinemaName = response.cinema[0].name;
            $scope.cinemaID = $routeParams.id;

        });
        
         // pega sessoes de acordo com o filme escolhido
        
        $scope.getShows = function(movie, cinema) {

            preLoadType('insert');

            $rootScope.modalMovieCinema = true;

            cinemas.getPosition(function(pos){                    
                movies.sessionsMovieCinema(movie,cinema,pos.coords.latitude, pos.coords.longitude).then(function(response){
                    preLoadType('remove');
                    if(!response.default && !response.special && !response.vip){                                                        
                        $mdToast.show(
                            $mdToast.simple({
                            textContent :   'Não existem sessões para este filme hoje.',
                            hideDelay   :   3000,
                            position    : 'top left',
                            action      : 'x'                                       
                        }));
                        return;
                    }

                    $mdDialog.show({
                      controller: DialogController,
                      templateUrl: 'views/modal/movies-sessions.tmpl.html',
                      parent: angular.element(document.body),                          
                      clickOutsideToClose:true,
                      fullscreen: 0,
                      locals: {
                        sessoes: response
                        }
                    });

                function DialogController($scope, sessoes, $mdDialog) {
                    $scope.sessoes = sessoes;

                    $scope.cancel = function() {
                        $mdDialog.cancel();
                    };

                    $scope.open = function(template, size) {

                        $scope.fullscreen = true;                        

                        if(size == 'small')
                            $scope.fullscreen = false;
                        else 
                            $scope.fullscreen = true;

                        $mdDialog.show({
                            controller: DialogController2,
                            templateUrl: 'views/modal/'+template+'.tmpl.html',
                            parent: angular.element(document.body),                                
                            fullscreen: $scope.fullscreen,                            
                        });
                    }

                    $scope.verifyDistancePosition = function ( session_id, type, state, hour, movie_name, theater_name, address, lat, lon, premium ){                   
                        $mdDialog.cancel();
                        preLoadType('insert');

                        //infos do usuario na sessao
                        var userInfo = (JSON.parse(localStorage.getItem('userPrime')));

                        /*
                        * registra na sessao os dados do filme/sessao escolhida/o
                        * independente isso tem que estar sempre antes da funcao de verificacao de login abaixo
                        */

                        var sessionInformation  = {id:session_id, type:type, hour: hour, name_movie:movie_name, theater_name: theater_name, address: address, latitude: lat, longitude: lon,state:state,premium:premium}
                        sessionStorage.setItem("sessionInformation",JSON.stringify(sessionInformation));            
                        // user no logged, send to login
                        if(!userInfo){
                            preLoadType('remove');  
                            $location.path('/login');
                        } else {                                            
                            cinemas.getPosition(function(pos){
                                user.status('verify',sessionInformation.id, pos.coords.latitude, pos.coords.longitude).then(function(response){
                                    if(response.status == 'danger'){
                                        preLoadType('remove');
                                        switch(response.code) {

                                            case 'NOSIGNATURE':
                                                var confirm = $mdDialog.confirm()
                                                    .parent(angular.element(document.querySelector('#popupContainer')))
                                                    .clickOutsideToClose(true)                                        
                                                    .textContent(response.message)                                    
                                                    .ok('conheça')
                                                    .cancel('voltar');

                                                $mdDialog.show(confirm).then(function() {
                                                    $scope.showAdvanced('','tela-inicial');
                                                }, function() {
                                                  console.log('continuar navegando');
                                                });
                                                break;

                                            case 'NOT24HOURS':
                                                var confirm = $mdDialog.confirm()
                                                        .parent(angular.element(document.querySelector('#popupContainer')))
                                                        .clickOutsideToClose(true)                                            
                                                        .textContent(response.message)                                    
                                                        .ok('meu local')
                                                        .cancel('voltar');

                                                    $mdDialog.show(confirm).then(function() {
                                                        $scope.showAdvanced('','modal-position','','small');
                                                    }, function() {
                                                      console.log('continuar navegando');
                                                    });
                                                    break;

                                            case 'NO3D':
                                                var confirm = $mdDialog.confirm()
                                                    .parent(angular.element(document.querySelector('#popupContainer')))
                                                    .clickOutsideToClose(true)
                                                    .title('Sessão')
                                                    .textContent(response.message)                                    
                                                    .ok('quero 3d')
                                                    .cancel('voltar');

                                                $mdDialog.show(confirm).then(function() {
                                                    $scope.redirectToWithSession('/panel/upgrade/');                                                  
                                                }, function() {
                                                  console.log('continuar navegando');
                                                });
                                                break;

                                            case 'NOWEEKDAY':
                                                var confirm = $mdDialog.confirm()
                                                    .parent(angular.element(document.querySelector('#popupContainer')))
                                                    .clickOutsideToClose(true)
                                                    .title('Sessão')
                                                    .textContent(response.message)                                    
                                                    .ok('quero')
                                                    .cancel('voltar');

                                                $mdDialog.show(confirm).then(function() {
                                                    $scope.redirectToWithSession('/panel/upgrade/');                                                  
                                                }, function() {
                                                  console.log('continuar navegando');
                                                });
                                                break;

                                            case 'NOVIP':
                                                var confirm = $mdDialog.confirm()
                                                    .parent(angular.element(document.querySelector('#popupContainer')))
                                                    .clickOutsideToClose(true)                                        
                                                    .textContent(response.message)                                    
                                                    .ok('quero ser vip')
                                                    .cancel('voltar');

                                                $mdDialog.show(confirm).then(function() {
                                                    $scope.redirectToWithSession('/panel/upgrade/');
                                                }, function() {
                                                  console.log('continuar navegando');
                                                });
                                                break;

                                            case 'NOSPECIAL':
                                                var confirm = $mdDialog.confirm()
                                                    .parent(angular.element(document.querySelector('#popupContainer')))
                                                    .clickOutsideToClose(true)                                        
                                                    .textContent(response.message)                                    
                                                    .ok('quero ser especial')
                                                    .cancel('voltar');

                                                $mdDialog.show(confirm).then(function() {
                                                    $scope.redirectToWithSession('/panel/upgrade/');
                                                }, function() {
                                                  console.log('continuar navegando');
                                                });
                                                break;

                                                case 'NOCARD':
                                                var confirm = $mdDialog.confirm()
                                                    .parent(angular.element(document.querySelector('#popupContainer')))
                                                    .clickOutsideToClose(true)                                        
                                                    .textContent(response.message)                                    
                                                    .ok('ativar')
                                                    .cancel('voltar');

                                                $mdDialog.show(confirm).then(function() {
                                                  $location.path('/desbloquear');                                     
                                                }, function() {
                                                  console.log('continuar navegando');
                                                });
                                                break;

                                            default:                            
                                                $mdDialog.show(
                                                    $mdDialog.alert()
                                                    .parent(angular.element(document.querySelector('#popupContainer')))
                                                    .clickOutsideToClose(true)                                        
                                                    .textContent(response.message)                                    
                                                    .ok('ok')
                                                );                                    
                                        }
                                    } else if(response.status == 'success') {
                                        preLoadType('remove');
                                        window.location = '#/card/' + sessionInformation.id;    
                                    } else {
                                        sessionStorage.setItem('movieID', "/moviesByCinema/"+cinema);
                                        preLoadType('remove');
                                        var confirm = $mdDialog.confirm()
                                            .parent(angular.element(document.querySelector('#popupContainer')))
                                            .clickOutsideToClose(true)
                                            .title('Sessão')
                                            .textContent('Ocorreu um erro em sua conexão.')                                   
                                            .ok('atualizar')
                                            .cancel('voltar');

                                        $mdDialog.show(confirm).then(function() {
                                            $location.path('/leave');
                                        }, function() {
                                          console.log('continuar navegando');
                                        });
                                    }
                                });
                            });                                                  
                        }                    
                    }
                }
                function DialogController2($scope, $mdDialog) {
                    $scope.cancel = function() {
                        $mdDialog.cancel(); 
                    }
                }
            });
        });
    }



        // fechar modal de sessoes
        $scope.closeModal = function(){
            console.log('here');
            $scope.modal__s = 'inactive';
        }

        // remove bg 
        $scope.removeThisBG = function(){
            $scope.metter = 'inactive';
        }

        // remove spin loading
        // remember this funcking shit, to use $apply, always use together with $timeout
        function removeLoading(){
            $timeout(function(){
                $scope.$apply(function(){
                    $scope.cardspin = 'inactive';
                    $scope.metter   = 'active';
                });
            },100);
        }         
        // funcao para verificar acessos do plano do usuario

        $scope.verifyDistancePosition = function ( session_id, type, state, hour, movie_name, theater_name, address, lat, lon, premium ){                   
            $mdDialog.cancel();
            preLoadType('insert');          
            // registra na sessao os dados do filme/sessao escolhida/o
            // independente isso tem que estar sempre antes da funcao de verificacao de login abaixo
            var sessionInformation  = {id:session_id, type:type, hour: hour, name_movie:movie_name, theater_name: theater_name, address: address, latitude: lat, longitude: lon,state:state,premium:premium}
            sessionStorage.setItem("sessionInformation",JSON.stringify(sessionInformation));            
            // user no logged, send to login
            if(!userInfo){
                preLoadType('remove');  
                $location.path('/login');
            }else{
                                
                cinemas.getPosition(function(pos){
                    user.status('verify',sessionInformation.id, pos.coords.latitude, pos.coords.longitude).then(function(response){
                        if(response.status == 'danger'){
                            preLoadType('remove');
                            $mdToast.show(
                                $mdToast.simple({
                                textContent :   response.message,
                                hideDelay   :   3000,
                                position    : 'top left',
                                action      : 'x'                                       
                            }));
                        } else if(response.status == 'success') {
                            preLoadType('remove');
                            window.location = '#/card/' + sessionInformation.id;
                        } else {
                            sessionStorage.setItem('movieID', "/moviesByCinema/"+cinema);                            
                            preLoadType('remove');
                            var confirm = $mdDialog.confirm()
                                .parent(angular.element(document.querySelector('#popupContainer')))
                                .clickOutsideToClose(true)
                                .title('Sessão')
                                .textContent('Ocorreu um erro em sua conexão.')                                   
                                .ok('atualizar')
                                .cancel('voltar');

                            $mdDialog.show(confirm).then(function() {
                                $location.path('/leave');
                            }, function() {
                              console.log('continuar navegando');
                            });
                        }
                    });
                });                                                  
            }                    
        }

    }]);

    myApp.controller("upgradeController",['$scope', '$interval', '$rootScope', '$mdDialog', 'plans', '$filter','user','$location', function($scope, $interval, $rootScope, $mdDialog, $plans, $filter, $user, $location){

        $scope.openSite = function() {
            $scope.showAdvanced('','tela-inicial','remove');
            window.open('https://goo.gl/dgPoZe', '_system', 'location=no','closebuttoncaption=back');
        }

        //CONTROLADORES DE TODOS OS PLANOS COM OU SEM 3D
        $scope.plan1_controller = 0;
        $scope.plan2_controller = 0;
        $scope.plan3_controller = 0;
        $scope.stateSlide = 0;

        var plans = {0:1, 1:2, 2:5, 3:6, 4:13, 5:14};
       
        /**
        * Troca planos do slider, modo infinito, 
        * vai trocar pra sempre se vc clicar
        */
        $scope.changePlan = function() {
            var currentSlide = $('.plansSlick').slick('slickCurrentSlide');                    

            if(currentSlide == 2 && $scope.stateSlide == 0) {
                $scope.stateSlide = 1;
                $('.slick-slider').slick('slickPrev');                                
            } else if($scope.stateSlide == 1) {
                if(currentSlide == 1) {
                    $('.slick-slider').slick('slickPrev');
                    console.log('este')
                } else if(currentSlide == 0){
                    $scope.stateSlide = 0;
                    $('.slick-slider').slick('slickNext');
                }                
            } else {
                $('.slick-slider').slick('slickNext');                                
            }            
        }

        /**
        *   Enviar usuario para checkout, 
            é importante saber que é preciso verificar o index do plano e 
            se o botao de 3d está ativo para não enviar com o id do plano errado
        **/
        $scope.sendCheckout = function() {
            preLoadType('insert');                        
            switch($('.plansSlick').slick('slickCurrentSlide')) {

                case 0:
                    console.log('slide 1');
                    $user.token().then(function(response){
                        console.log(response);
                        preLoadType('remove');
                        if(response.status == 'success') {
                            if($scope.plan1_controller == 0)
                                var index = plans[0];
                            else
                                var index = plans[1];

                            window.open('https://app.primepass.club/auth/service?token='+response.token+'&plan_id='+index, '_system', 'location=yes','closebuttoncaption=back,toolbar=yes');
                        } else {
                            console.log('deu ruim');
                        }
                    });
                    break;

                case 1:
                    console.log('slide 2');                
                    $user.token().then(function(response){
                        preLoadType('remove');                        
                        if(response.status == 'success') {
                            if($scope.plan2_controller == 0)
                                var index = plans[2];                                
                            else
                                var index = plans[3];

                            window.open('https://app.primepass.club/auth/service?token='+response.token+'&plan_id='+index, '_system', 'location=yes','closebuttoncaption=back,toolbar=yes');
                        } else {
                            console.log('deu ruim');
                        }
                    });                  
                    break;

                case 2:
                    console.log('slide 3');                
                    $user.token().then(function(response){
                        preLoadType('remove');                        
                        if(response.status == 'success') {
                            if($scope.plan3_controller == 0)
                                var index = plans[4];                                
                            else
                                var index = plans[5];         

                            window.open('https://app.primepass.club/auth/service?token='+response.token+'&plan_id='+index, '_system', 'location=yes','closebuttoncaption=back,toolbar=yes');
                        } else {
                            console.log('deu ruim');
                        }
                    });                   
                    break;

                default:
                    console.log('Selecione um plano para poder adicionar 3d');                    
            }
        }

        /**
            Muda o status do plano para 3d ou normal
        **/
        $scope.changePlanStatus = function(evento) {
            

            // console.log($('.plansSlick').slick('slickCurrentSlide'));
            
            switch($('.plansSlick').slick('slickCurrentSlide')) {

                case 0:
                    console.log('Plano Básico');
                    if($scope.plan1_controller == 0) {
                        $scope.plan1_name = $scope.activePlans[0+1].name;
                        $scope.plan1_value = $scope.activePlans[0+1].value;
                        $scope.plan1_controller = 1;
                    } else {
                        $scope.plan1_name = $scope.activePlans[0].name;
                        $scope.plan1_value = $scope.activePlans[0].value;
                        $scope.plan1_controller = 0;
                    }

                    break;

                case 1:
                    console.log('Plano Padrão');
                    if($scope.plan2_controller == 0) {
                        $scope.plan2_name = $scope.activePlans[2+1].name;
                        $scope.plan2_value = $scope.activePlans[2+1].value;
                        $scope.plan2_controller = 1;
                    } else {                        
                        $scope.plan2_name = $scope.activePlans[2].name;
                        $scope.plan2_value = $scope.activePlans[2].value;
                        $scope.plan2_controller = 0;
                    }
                    break;

                case 2:
                    console.log('Plano VIP');
                    if($scope.plan3_controller == 0) {
                        $scope.plan3_name = $scope.activePlans[4+1].name;
                        $scope.plan3_value = $scope.activePlans[4+1].value;
                        $scope.plan3_controller = 1;
                    } else {
                        $scope.plan3_name = $scope.activePlans[4].name;
                        $scope.plan3_value = $scope.activePlans[4].value;
                        $scope.plan3_controller = 0;
                    }                 
                    break;

                default:
                    console.log('Selecione um plano para poder adicionar 3d');
            }
        }                

        /**
        * API DE PLANOS DO CHECKOUT
        **/

        $plans.getPlans().then(function(response){
            $scope.activePlans = response.data;
            console.log(response.data[0].name)                       


            //nao tive tempo de fazer algo melhor, na verdade eu nunca tenho
            $scope.plan1_name = response.data[0].name;
            $scope.plan2_name = response.data[2].name;
            $scope.plan3_name = response.data[4].name;


            $scope.plan1_value = response.data[0].value;
            $scope.plan2_value = response.data[2].value;
            $scope.plan3_value = response.data[4].value;

        });

        /**
        * Modal material, todas as pagians deverão ser assim
        * por enquanto só planos segue esse conceito
        **/
        $scope.showAdvanced = function(ev,template,type) {
            
            // Tipo remove cancela um dialog e abre outor
            if(type == 'remove'){
                $mdDialog.cancel();
                return;
            }


            $mdDialog.show({
                controller: DialogController,
                templateUrl: 'views/modal/'+template+'.tmpl.html',
                parent: angular.element(document.body),
                targetEvent: ev,
                clickOutsideToClose:true,
                fullscreen: true // Only for -xs, -sm breakpoints.
            })
            .then(function(answer) {
                console.log('aqui');
            }, function() {
                console.log('errou');
            });        
        };

        function DialogController($scope, $mdDialog, $location) {
            
            $scope.hide = function() {
                $mdDialog.hide();
            };

            $scope.cancel = function() {
                $mdDialog.cancel();
            };

            $scope.answer = function(answer) {
                $mdDialog.hide(answer);
            };

            $scope.sendView = function(view) {
                console.log('aqui porra');
                $scope.cancel();
                $location.path(view); // path not hash

            }
        } 

        /*
         * Troca a view (url) através de elementos
         */
        $scope.changeView = function(view) {
        $scope.cancel();  
            console.log(view);
            if(view == '/true')
                $location.path('/profile')
            else if(view == '/false')
                $location.path('/login');

            // Close menu in case of transition            
            if($scope.showMenu == true)
                $scope.setMenuState();

            // Change path
            $location.path(view); // path not hash
        }       
    }]);

    myApp.controller("testeController",['$scope',function($scope){

    }]);


    myApp.controller("registerController",['$scope','$location','user','$rootScope','$location','$base64','$mdToast','$mdDialog','cinemas', function($scope,$location,user,$rootScope,$location,$base64,$mdToast, $mdDialog, cinemas){
        var device = JSON.parse(localStorage.getItem('deviceInfo'));

        $scope.hideOverlay = function(){
            $scope.loginError = '';
        }
        
        $scope.registerUser = function(){
            var er = /^[a-zA-Z0-9][a-zA-Z0-9\._-]+@([a-zA-Z0-9\._-]+\.)[a-zA-Z-0-9]{2,3}/;

            if(device.platform != 'iOS')                
                preLoadType('insert','Registro','Por favor, aguarde enquanto sincronizamos sua nova conta PrimePass!');
            else                
                preLoadType('insert','Registro','Sincronizando nova conta');

            if(!er.exec($scope.email)){
                    preLoadType('remove');
                    $mdDialog.show(
                        $mdDialog.alert()
                        .parent(angular.element(document.querySelector('#popupContainer')))
                        .clickOutsideToClose(true)                                
                        .textContent('Oops! O email digitado não é válido, por favor digite novamente')                                    
                        .ok('ok')
                    );
                    return;
            }

            if(!$scope.name || !$scope.middlename || !$scope.email || !$scope.pass) {
                preLoadType('remove');
                $mdDialog.show(
                    $mdDialog.alert()
                    .parent(angular.element(document.querySelector('#popupContainer')))
                    .clickOutsideToClose(true)                                
                    .textContent('Não se esqueça de preencher todos os campos.')                                    
                    .ok('ok')
                );                            
                return;
            }else{
             
                if($scope.name.length <3){
                    preLoadType('remove');                    
                    $mdDialog.show(
                        $mdDialog.alert()
                        .parent(angular.element(document.querySelector('#popupContainer')))
                        .clickOutsideToClose(true)                                
                        .textContent('O nome deve conter mais do que 4 letras')                                    
                        .ok('ok')
                    );  
                    return;
                }

                if($scope.middlename.length <=3){
                    preLoadType('remove');                                    
                    $mdDialog.show(
                        $mdDialog.alert()
                        .parent(angular.element(document.querySelector('#popupContainer')))
                        .clickOutsideToClose(true)                                
                        .textContent('O sobrenome deve conter mais do que 3 letras')                                    
                        .ok('ok')
                    );
                    return;
                }                            

                if($scope.pass.length <= 7){
                    preLoadType('remove');                    
                    $mdDialog.show(
                        $mdDialog.alert()
                        .parent(angular.element(document.querySelector('#popupContainer')))
                        .clickOutsideToClose(true)                                
                        .textContent('A senha deve ser maior ou igual á 8 digitos')                                    
                        .ok('ok')
                    );
                    return;
                }               
                
            }

            user.register($scope.name, $scope.middlename, $scope.email, $scope.pass).then(function(response){
                localStorage.setItem("auth","Basic "+$base64.encode($scope.email+':'+$scope.pass));
                if(response.status == 'error') {
                    localStorage.removeItem('auth');    
                    preLoadType('remove');
                    $mdDialog.show(
                        $mdDialog.alert()
                        .parent(angular.element(document.querySelector('#popupContainer')))
                        .clickOutsideToClose(true)                                
                        .textContent('Esta conta de email já existe em nosso sistema. Por favor tente outro email')                                    
                        .ok('ok')
                    );                
                } else {
                    user.login($scope.email,$scope.pass, device.model, device.platform, device.device_uuid, 'normal').then(function(response) {
                        
                        localStorage.setItem("userPrime",JSON.stringify(response.data));
                        //variaveis globais para mostrar menu logado e image user se houver
                        $rootScope.is_log    = 'true'; // seta menu para mostrar que esta logado
                        $rootScope.imageUser = response.data.picture; // imagem do usuario
                        $rootScope.name__user    = response.data.name+' '+response.data.middlename;
                        $rootScope.cardact   = response.data.card_prime_ID;
                        // agora precisa da info do user e se houver sessao ele continua
                        var userInfo = JSON.parse(localStorage.getItem('userPrime'));
                        var sessionInfo = JSON.parse(sessionStorage.getItem("sessionInformation"));                                            

                        if(sessionInfo == null) {
                            preLoadType('remove');                            
                            // mada usuario para tela de perfil
                            $location.path('/profile');                            
                            $mdDialog.show(
                                $mdDialog.alert()
                                .parent(angular.element(document.querySelector('#popupContainer')))
                                .clickOutsideToClose(true)                                
                                .textContent('Bem vindo a PrimePass. Seu cadastro foi efetuado com sucesso.')                                    
                                .ok('continuar')
                            ); 
                        } else {
                            preLoadType('remove');                                          
                            cinemas.getPosition(function(pos) {
                                user.status('verify',sessionInfo.id, pos.coords.latitude, pos.coords.longitude).then(function(response){
                                    if(response.status == 'danger') {
                                        preLoadType('remove');
                                        switch(response.code) {

                                            case 'NOSIGNATURE':
                                                var confirm = $mdDialog.confirm()
                                                    .parent(angular.element(document.querySelector('#popupContainer')))
                                                    .clickOutsideToClose(true)                                        
                                                    .textContent(response.message)                                    
                                                    .ok('conheça')
                                                    .cancel('voltar');

                                                $mdDialog.show(confirm).then(function() {
                                                    $scope.showAdvanced('','tela-inicial');
                                                }, function() {
                                                  console.log('continuar navegando');
                                                });
                                                break;

                                            case 'NOT24HOURS':
                                                var confirm = $mdDialog.confirm()
                                                        .parent(angular.element(document.querySelector('#popupContainer')))
                                                        .clickOutsideToClose(true)                                            
                                                        .textContent(response.message)                                    
                                                        .ok('meu local')
                                                        .cancel('voltar');

                                                    $mdDialog.show(confirm).then(function() {
                                                        $scope.showAdvanced('','modal-position','','small');
                                                    }, function() {
                                                      console.log('continuar navegando');
                                                    });
                                                    break;

                                            case 'NO3D':
                                                var confirm = $mdDialog.confirm()
                                                    .parent(angular.element(document.querySelector('#popupContainer')))
                                                    .clickOutsideToClose(true)
                                                    .title('Sessão')
                                                    .textContent(response.message)                                    
                                                    .ok('quero 3d')
                                                    .cancel('voltar');

                                                $mdDialog.show(confirm).then(function() {
                                                  $scope.redirectToWithSession('/panel/upgrade/');
                                                }, function() {
                                                  console.log('continuar navegando');
                                                });
                                                break;

                                            case 'NOWEEKDAY':
                                                var confirm = $mdDialog.confirm()
                                                    .parent(angular.element(document.querySelector('#popupContainer')))
                                                    .clickOutsideToClose(true)
                                                    .title('Sessão')
                                                    .textContent(response.message)                                    
                                                    .ok('quero')
                                                    .cancel('voltar');

                                                $mdDialog.show(confirm).then(function() {
                                                  $scope.redirectToWithSession('/panel/upgrade/');                                                                        
                                                }, function() {
                                                  console.log('continuar navegando');
                                                });
                                                break;

                                            case 'NOVIP':
                                                var confirm = $mdDialog.confirm()
                                                    .parent(angular.element(document.querySelector('#popupContainer')))
                                                    .clickOutsideToClose(true)                                        
                                                    .textContent(response.message)                                    
                                                    .ok('quero ser vip')
                                                    .cancel('voltar');

                                                $mdDialog.show(confirm).then(function() {
                                                  $scope.redirectToWithSession('/panel/upgrade/');                                                                        
                                                }, function() {
                                                  console.log('continuar navegando');
                                                });
                                                break;

                                            case 'NOSPECIAL':
                                                var confirm = $mdDialog.confirm()
                                                    .parent(angular.element(document.querySelector('#popupContainer')))
                                                    .clickOutsideToClose(true)                                        
                                                    .textContent(response.message)                                    
                                                    .ok('quero ser especial')
                                                    .cancel('voltar');

                                                $mdDialog.show(confirm).then(function() {
                                                  $scope.redirectToWithSession('/panel/upgrade/');
                                                }, function() {
                                                  console.log('continuar navegando');
                                                });
                                                break;

                                                case 'NOCARD':
                                                var confirm = $mdDialog.confirm()
                                                    .parent(angular.element(document.querySelector('#popupContainer')))
                                                    .clickOutsideToClose(true)                                        
                                                    .textContent(response.message)                                    
                                                    .ok('ativar')
                                                    .cancel('voltar');

                                                $mdDialog.show(confirm).then(function() {
                                                  $location.path('/desbloquear');                                     
                                                }, function() {
                                                  console.log('continuar navegando');
                                                });
                                                break;

                                            default:                            
                                                $mdDialog.show(
                                                    $mdDialog.alert()
                                                    .parent(angular.element(document.querySelector('#popupContainer')))
                                                    .clickOutsideToClose(true)                                        
                                                    .textContent(response.message)                                    
                                                    .ok('ok')
                                                );                                    
                                        }
                                        window.history.back();
                                    } else {
                                        preLoadType('remove');
                                        window.location = '#/card/' + sessionInfo.id;
                                    }
                                });
                            });
                        }                                                
                    });
                }
            });            
        }

    }]);

    /**
    * Abstract Controller Tutorial include mode
    **/
    myApp.controller("tutorialController",['$scope','$rootScope', 'snapRemote', function($scope, $rootScope, snapRemote){
        preLoadType('remove');
        $scope.currentPage = 'page1';
        $scope.page1 = true;
        $scope.page1On = 'active';
        $scope.page2 = false;
        $scope.onSwipe = function(page, direction) {
            if(page == 'page1') {
                if(direction == 'left') {
                    $scope.page1 = false;
                    $scope.page2 = true;
                    $scope.page1On = '';
                    $scope.page3On = '';
                    $scope.page4On = '';
                    $scope.page5On = '';
                    $scope.page2On = 'active';
                    $scope.currentPage = 'page2';
                }
            }

            if(page == 'page2') {
                if(direction == 'left') {
                    $scope.page2 = false;
                    $scope.page3 = true;
                    $scope.page1On = '';
                    $scope.page2On = '';
                    $scope.page5On = '';
                    $scope.page4On = '';
                    $scope.page3On = 'active';
                    $scope.currentPage = 'page3';
                }else {
                    $scope.page2 = false;
                    $scope.page1 = true;
                    $scope.page1On = '';
                    $scope.page2On = '';
                    $scope.page3On = '';
                    $scope.page4On = '';
                    $scope.page1On = 'active';
                    $scope.currentPage = 'page1';                    
                }
            }

            if(page == 'page3') {
                if(direction == 'left') {
                    $scope.page3 = false;
                    $scope.page4 = true;
                    $scope.page1On = '';
                    $scope.page2On = '';
                    $scope.page3On = '';
                    $scope.page5On = '';
                    $scope.page4On = 'active';
                    $scope.currentPage = 'page4';                    
                }else {
                    $scope.page3 = false;
                    $scope.page2 = true;
                    $scope.page1On = '';
                    $scope.page3On = '';
                    $scope.page4On = '';
                    $scope.page5On = '';
                    $scope.page2On = 'active';
                    $scope.currentPage = 'page2';                    
                }
            }

            if(page == 'page4') {
                if(direction == 'left') {
                    $scope.page4 = false;
                    $scope.page5 = true;
                    $scope.page1On = '';
                    $scope.page2On = '';
                    $scope.page3On = '';
                    $scope.page4On = '';
                    $scope.page5On = 'active';
                    $scope.currentPage = 'page5';                    
                }else {
                    $scope.page4 = false;
                    $scope.page3 = true;
                    $scope.page1On = '';
                    $scope.page2On = '';
                    $scope.page4On = '';
                    $scope.page5On = '';
                    $scope.page3On = 'active';
                    $scope.currentPage = 'page3';
                }
            }

            if(page == 'page5') {
                if(direction == 'left') {
                    return;                    
                }else {
                    $scope.page5 = false;
                    $scope.page4 = true;
                    $scope.page1On = '';
                    $scope.page2On = '';
                    $scope.page3On = '';
                    $scope.page5On = '';
                    $scope.page4On = 'active';
                }
            }
        }
    }]);

    /**
    * Desbloquear cartao
    **/
    myApp.controller("unlockController",['$scope','$rootScope','$location','$timeout','card','user',function($scope,$rootScope,$location,$timeout,card,user){

        var userInfo = JSON.parse(localStorage.getItem("userPrime")); 
        console.log(userInfo);        
        $scope.cardNumber   = '';
        $scope.firstPass    = '';
        $scope.secondPass   = '';

        $scope.checkInput = function() {
            if(cordova.platformId != 'ios') {
                document.getElementsByClassName('card-box-information')[0].style.marginTop = '-180%';                 
            }
        }             

        $scope.unlockCard = function() {
            preLoadType('insert');                        

            if($scope.cardNumber == '' || $scope.cardNumber.length < 16 || $scope.cardNumber.length > 16 ){                
                showMessage('Verifique o número do cartão PrimePass digitado.','Erro','voltar');
                preLoadType('remove');            
                return;
            }

                
            if($scope.firstPass.length < 4 || $scope.firstPass == '' ) {
                showMessage('A senha deve ter 4 dídigitos.','Erro','voltar');
                preLoadType('remove');                
                return;
            }                                

            if($scope.secondPass.length < 4 || $scope.secondPass == '' ) {
                showMessage('A senha deve ter 4 dídigitos.','Erro','voltar');                
                preLoadType('remove');                
                return;
            }
             

            if($scope.firstPass != $scope.secondPass) {
                showMessage('As senhas não estão iguais','Erro','voltar');
                preLoadType('remove');                            
                return;
            }   

            // Faz a requisiçao ajax
                card.active($scope.cardNumber, userInfo.id, $scope.firstPass).then(function(response) {
                    console.log(response);
                    // check for success
                    if(response.success == 'true') {
                        user.dataUser(userInfo.id).then(function(response) {
                            console.log(response);
                            preLoadType('remove');                            

                            //login
                            localStorage.setItem("userPrime",JSON.stringify(response.data));
                    
                            //hash login
                            localStorage.setItem("hashLogin",response.hash);                                                    

                            $rootScope.cardact = response.card_prime_ID;
                            showMessage('Seu cartão PrimePass foi desbloqueado com sucesso.','PrimePass','CONTINUAR NAVEGANDO');                            
                            $location.path('/');
                        });
                    } else {
                        preLoadType('remove');
                        showMessage(response.message,'PrimePass','inicio');                        
                    }
                });   
        }

    }]);

    