/**
*	Algumas referencias de contato para Primepass
*/

myApp.service('contato',function(){

	return ({
		createContact: createPrimeContact,
		openWhatSapp: openPrimeWhats,		
	});


	/**
	* Verifica se existe um contato da Prime
	* se nao existir, cria um
	*/

	function createPrimeContact() {	
        
        // find all contacts with 'Atendimento PrimePass' in any name field
        var options      = new ContactFindOptions();
        options.filter   = "Atendimento Primepass";
        options.multiple = true;
        // options.desiredFields = [navigator.contacts.fieldType.id];
        options.hasPhoneNumber = true;
        var fields = ["*"];

        navigator.contacts.find(fields, function(contacts){

            if(contacts.length == 0) {
                var contact = navigator.contacts.create({"displayName": "PrimePass Atendimento"});
                
                var name = new ContactName();
                name.givenName = "Atendimento";
                name.familyName = "PrimePass";
                contact.name = name;

                var phoneNumbers = [];
                phoneNumbers[0] = new ContactField('mobile', '+5511974910725', true);

                contact.phoneNumbers = phoneNumbers;

                contact.save(function(data){                        
                    console.log('contato adicionado');
                    localStorage.setItem("celPrime",data.id);
                },function(){
                	console.log('error');
                });
            } else {                                            
                localStorage.setItem("celPrime",contacts[0].id);
            } 
        }, function(contactError) {
        	console.log('deu ruim');
        }, options);
	}

	/**
	* Abre o aplicativo Whatsapp direcionado
	* para o numero da prime, se caso o usuario tiver um
	*/
	function openPrimeWhats() {

        //device info
        if(localStorage.getItem('deviceInfo'))
            var device = JSON.parse(localStorage.getItem('deviceInfo'));        

		//Pega abid do storage(eh bom que esteja la)
		var abID = localStorage.getItem("celPrime");


		//Verifica se é possível abrir o aplicativo
		window.plugins.socialsharing.canShareVia('whatsapp', null, null, null, null, function(e) {
			if(device.platform == 'iOS')
                window.plugins.socialsharing.shareViaWhatsAppToReceiver(abID, '', null /* img */, null /* url */, function() {console.log('share ok')});
            else
                window.plugins.socialsharing.shareViaWhatsAppToReceiver('+5511974910725', '', null /* img */, null /* url */, function() {console.log('share ok')});

		}, function(e){alert('Verifique seu aplicativo Whatsapp.')});
	}

});
