myApp.directive("preloadSession",function() {

	return {

		template: 					
					'<md-progress-circular md-mode="indeterminate" ng-if="!data" class="progressive-session"></md-progress-circular>'+
					'<div class="sessions-appear" ng-class="color" ng-cloak>'+						
						'<div ng-repeat="cinemas in sessions" class="section__theater">'+
							'<div layout="row" class="cinema__choose {{cinemas.premium == 0 ?\'normal\':\'premium\'}}">'+
								'<div flex class="cinema__icon">'+
									'<img src="{{cinemas.premium == 0 ?\'img/spin.png\':\'img/spin_premium.png\'}}" height="25" />'+
								'</div>'+
								'<div flex class="cinema__choose__title2">'+
									'<span class="isBold">Cinema: {{cinemas.cinema}}</span><br>'+
									'{{cinemas.address}} {{cinemas.cep}}'+
								'</div>'+
							'</div>'+
							'<div flex layout-wrap class="cinema_ticket {{cinemas.premium == 0 ?\'normal\':\'premium\'}}" ng-if="cinemas.default == \'true\'">'+
								'<div flex="100" class="title__session">Salas Padrão</div>'+
								'<div layout="row" layout-wrap>'+
									'<a flex="24" ng-click="verifyDistancePosition(sessao.id,sessao.type_2,sessao.type_3,sessao.hour,name,cinemas.cinema,cinemas.address,cinemas.latitude, cinemas.longitude, cinemas.premium)" class="ticket_time" ng-repeat="sessao in cinemas.sessoes.default">'+
										'<span class="session_type first_{{sessao.secondColor}}">{{sessao.hour}}</span><span class="tag_type session_type sec_{{sessao.firstColor}}">{{sessao.type_2}}</span>'+
									'</a>'+
								'</div>'+
							'</div>'+

							'<div flex="100" flex class="cinema_ticket {{cinemas.premium == 0 ?\'normal\':\'premium\'}}" ng-if="cinemas.special == \'true\'">'+
								'<div class="title__session">Salas Especiais</div>'+
								'<div layout="row" layout-wrap>'+
									'<a flex="24" ng-click="verifyDistancePosition(sessao.id,sessao.type_2,sessao.type_3,sessao.hour,name,cinemas.cinema,cinemas.address,cinemas.latitude, cinemas.longitude, cinemas.premium)" class="ticket_time" ng-repeat="sessao in cinemas.sessoes.special">'+
										 '<span class="session_type first_{{sessao.secondColor}}_scp">{{sessao.hour}}</span><span class="tag_type session_type sec_{{sessao.firstColor}}_scp">{{sessao.type_2}}</span>'+
									'</a>'+
								'</div>'+
							'</div>'+

							'<div flex class="cinema_ticket {{cinemas.premium == 0 ?\'normal\':\'premium\'}}" ng-if="cinemas.vip == \'true\'">'+
								'<div flex="100" class="title__session">Salas Vip</div>'+
								'<div layout="row" layout-wrap>'+
									'<a ng-click="verifyDistancePosition(sessao.id,sessao.type_2,sessao.type_3,sessao.hour,name,cinemas.cinema,cinemas.address,cinemas.latitude, cinemas.longitude, cinemas.premium)" class="ticket_time" ng-repeat="sessao in cinemas.sessoes.vip">'+
										 '<span class="session_type first_{{sessao.secondColor}}_vp">{{sessao.hour}}</span><span class="tag_type session_type sec_{{sessao.firstColor}}_vp">{{sessao.type_2}}</span>'+
									'</a>'+
								'</div>'+
							'</div>'+

							'<div flex layout-wrap class="cinema_ticket normal" ng-if="cinemas.vip == \'false\' && cinemas.default == \'false\' && cinemas.special == \'false\'">'+
								'<span class="session_type no_session">Não há mais sessões disponíveis hoje.</span>'+
							'</div>'+
						'</div>'+
				  	'</div>',
		controller: ['$scope','$routeParams', 'cinemas', 'movies', '$location', function($scope, $routeParams, cinemas, movies, $location){
			
			console.log($location.path())
			//variavel de controle do spinner
	        $scope.data = false;

	        //trazendo sessoes de acordo com posicao e url do filme
	        cinemas.getPosition(function(pos){
	            movies.session($routeParams.id,pos.coords.latitude,pos.coords.longitude).then(function(sessions){
                	$scope.sessions = sessions;
                	$scope.data = true;
                	$scope.color = 'active';
	            });
	        });
		}]
		
	}

});