/**
* URBAN AIRSHIP METHODS
*/

myApp.service('urbanAirShip',function() {

	return ({
		setName: setName,
		getChannel: getChannel,
		setAlias: setAlias,
		getPush: getPushReceived,
		setTags: setTag,
		enablePush: enableNotifications,
	});


	//Se precisar pegar channelID
	function getChannel(callback) {
		UAirship.getChannelID(function (channelID) {
            callback(channelID);
        });
	}

	//seta Alias para usuario
	function setAlias(name) {
		UAirship.setAlias(name);
	}

	//libera notificacoes inside app
	function enableNotifications() {
        UAirship.setUserNotificationsEnabled(true, function (enabled) {
        	console.log(JSON.stringify(enabled));
    	});
	}

	/**
	* Recebe conteudo que foi enviado via push
	* se caso precisar, utilizar esse conteudo customizado em alguma showBox
	*/
	function getPushReceived(callback) {
		UAirship.getLaunchNotification(false,
            function(push) { 
                callback(push);
            } 
        );
	}

	//Seta um nome ou remove, dependendo do type
	function setName(name, type) {
		if(type == 'remove') 
			UAirship.setNamedUser(null);
		else
			UAirship.setNamedUser(name);

	}

	function setTag(data) {
		UAirship.setTags(data);
	}

                
});

