myApp.directive("passReleased", function($timeout){

	return {

		template:'<div ng-include="fullPath"></div>',
		controller: ['$scope', 'card', '$location', function($scope, $card, $location){
 
			if(localStorage.getItem('userPrime')) {

				let _dataUser = JSON.stringify(localStorage.getItem('userPrime'));
				$card.cardInformation().then(function(response) {
					if(response.status == 'true') {
						// console.log(response.lastCardNumbers+'-'+response.cardPassword);						
						$scope.number = response.lastCardNumbers;
						$scope.password  =  response.cardPassword;											
					}
				});				

				/** Variavel que manda o path do template de acordo com a rede escolhida **/
    			$scope.fullPath = 'views/modal/passe-sucesso.tmpl.html';

    			$scope.passBind = 'hide-pass';
    			$scope.instrucaoBind = '';

    			$scope.changeView = function() {
    				$location.path('/');
    			}

			}
		}],

		link: function($scope, $element, $attr) {

			$element.bind('click', function(evt) {

				//Só deixa aparecer se for no elemento que comporta a senha
				if(	angular.element(evt.target).hasClass('pressionar-ver') |
					angular.element(evt.target).hasClass('titulo-senha-cupom') |
					angular.element(evt.target).hasClass('fa fa-eye') |
					angular.element(evt.target).hasClass('fa fa-eye-slash'))	
				{

					$scope.$apply(function() {

						if ($scope.passBind === 'hide-pass')
						{											
							$scope.passBind = 'show-pass';
							$scope.instrucaoBind = 'hide-instrucao';							
						} else if($scope.passBind === 'show-pass')
						{					
							$scope.passBind = 'hide-pass';
							$scope.instrucaoBind = '';						
						}
					});					

					
				}
			});		
		}
	}
});