    // ==================================================
    // == Rotas
    // ==================================================
    
    myApp.config(function($routeProvider, $locationProvider) {
    	$routeProvider
    		.when('/', {
    			templateUrl: 'views/home.html',
    			controller : 'homeController'
    		})
            .when('/soon', {
                templateUrl: 'views/movielist-soon.html',
                controller : 'soonController'
            })
            .when('/movie/:id', {
                templateUrl: 'views/movie-detail.html',
                controller : 'movieController'
            })
            .when('/card/:url', {
                templateUrl: 'views/card.html',
                controller : 'cardController'
            })
            .when('/success/', {
                templateUrl: 'views/card-success.html',
                controller : 'cardSuccessController'
            })
            .when('/login', {
                templateUrl: 'views/login.html',
                controller : 'loginController'
            })
            .when('/cinema',{
                templateUrl : 'views/cinema.html',
                controller : 'cinemaController'
            })                         
            .when('/leave',{
                template : '',
                controller : 'leaveController'
            }) 
            .when('/profile',{
                templateUrl: 'views/profile.html',
                controller : 'profileController'
            })
            .when('/terms',{                
                controller : 'termsController'
            }) 
            .when('/politics',{
                templateUrl: 'views/politics.html',
                controller : 'politicsController'
            }) 
            .when('/help',{
                templateUrl: 'views/help.html',
                controller : 'helpController'
            })
            .when('/history',{
                templateUrl: 'views/history.html',
                controller : 'historyController'
            })
            .when('/moviesByCinema/:id',{
                templateUrl : 'views/moviesCinema.html',
                controller : 'moviesByCinemaListController'
            })
            .when('/register',{
                templateUrl: 'views/register.html',
                controller : 'registerController'
            })
            .when('/tutorial',{
                templateUrl: 'views/tutorial.html',
                controller : 'tutorialController'
            })
            .when('/desbloquear',{
                templateUrl: 'views/unlock.html',
                controller : 'unlockController'
            })
            .when('/dialog/:template',{
                templateUrl: 'views/blank.html',
                controller : 'fullDialogController'
            })
            .when('/teste',{
                templateUrl: 'views/upgrade.html',
                controller : 'upgradeController'
            })
            .when('/cupom/:rede',{
                templateUrl: 'views/cupom.html'
            })            
            .when('/passe',{
                templateUrl: 'views/passe.html'
            })
    		.otherwise({
    			redirectTo: '/'
    		});
    	// $locationProvider.html5Mode(true);
    });